// Copyright (c) 2022 NetEase, Inc. All rights reserved.
// Use of this source code is governed by a MIT license that can be
// found in the LICENSE file.

import 'package:nertc_core_platform_interface/nertc_core_platform_interface.dart';
import 'package:nertc_core_platform_interface/pigeon.dart';

class MethodChannelNERtcVideoRender extends NERtcVideoRenderPlatform {
  final _api = VideoRendererApi();

  @override
  Future<int> createVideoRenderer() async {
    return await _api.createVideoRenderer();
  }

  @override
  Future<int> setMirror(int textureId, bool mirror) async {
    return await _api.setMirror(textureId, mirror);
  }

  @override
  Future<int> setupLocalSubStreamVideoRenderer(int textureId) async {
    return await _api.setupLocalSubStreamVideoRenderer(textureId);
  }

  @override
  Future<int> setupLocalVideoRenderer(int textureId) async {
    return await _api.setupLocalVideoRenderer(textureId);
  }

  @override
  Future<int> setupRemoteSubStreamVideoRenderer(int uid, int textureId) async {
    return await _api.setupRemoteSubStreamVideoRenderer(uid, textureId);
  }

  @override
  Future<int> setupRemoteVideoRenderer(int uid, int textureId) async {
    return await _api.setupRemoteVideoRenderer(uid, textureId);
  }

  @override
  Future<void> disposeVideoRenderer(int textureId) async {
    await _api.disposeVideoRenderer(textureId);
  }
}
