// Copyright (c) 2022 NetEase, Inc. All rights reserved.
// Use of this source code is governed by a MIT license that can be
// found in the LICENSE file.

import 'package:nertc_core_platform_interface/nertc_core_platform_interface.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';

abstract class NERtcDevicePlatform extends PlatformInterface {
  NERtcDevicePlatform() : super(token: _token);

  static final Object _token = Object();

  static NERtcDevicePlatform _instance = MethodChannelNERtcDevice();

  static NERtcDevicePlatform get instance => _instance;

  static set instance(NERtcDevicePlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  void addRtcDeviceListener(NERtcDeviceEventSink sink);

  void removeRtcDeviceListener(NERtcDeviceEventSink sink);

  Future<int> switchCamera();

  Future<int> setCameraZoomFactor(double factor);

  Future<double> getCameraMaxZoom();

  Future<int> setCameraTorchOn(bool on);

  Future<int> setCameraFocusPosition(double x, double y);

  Future<int> setCameraExposurePosition(double x, double y);

  Future<bool> isCameraZoomSupported();

  Future<bool> isCameraTorchSupported();

  Future<bool> isCameraFocusSupported();

  Future<bool> isCameraExposurePositionSupported();

  Future<int> setPlayoutDeviceMute(bool mute);

  Future<bool> isPlayoutDeviceMute();

  Future<int> setRecordDeviceMute(bool mute);

  Future<bool> isRecordDeviceMute();

  Future<int> setSpeakerphoneOn(bool enable);

  Future<bool> isSpeakerphoneOn();

  Future<int> enableEarback(bool enabled, int volume);

  Future<int> setEarbackVolume(int volume);

  Future<int> setAudioFocusMode(int focusMode);

  ///android
  Future<int> getCurrentCamera();

  Future<int> switchCameraWithPosition(int position);

  ///android
  Future<int> getCameraCurrentZoom();
}
