// Copyright (c) 2022 NetEase, Inc. All rights reserved.
// Use of this source code is governed by a MIT license that can be
// found in the LICENSE file.

import 'package:plugin_platform_interface/plugin_platform_interface.dart';
import '../method_channel/nertc_stats_method_channel.dart';
import '../pigeon.dart';

abstract class NERtcStatsPlatform extends PlatformInterface {
  static final Object _token = Object();

  NERtcStatsPlatform() : super(token: _token);

  static NERtcStatsPlatform _instance = MethodChannelNERtcStats();

  static NERtcStatsPlatform get instance => _instance;

  static set instance(NERtcStatsPlatform instance) {
    PlatformInterface.verify(instance, _token);
    _instance = instance;
  }

  void registerStatsListener(NERtcStatsEventSink listener);

  void unregisterStatsListener(NERtcStatsEventSink listener);
}

abstract class NERtcLiveStreamPlatform extends PlatformInterface {
  static final Object _token = Object();

  NERtcLiveStreamPlatform() : super(token: _token);

  static NERtcLiveStreamPlatform _instance = MethodChannelNERtcLiveStream();

  static NERtcLiveStreamPlatform get instance => _instance;

  static set instance(NERtcLiveStreamPlatform instance) {
    PlatformInterface.verify(instance, _token);
    _instance = instance;
  }

  void registerLiveStreamListener(NERtcLiveStreamEventSink listener);

  void unregisterLiveStreamListener(NERtcLiveStreamEventSink listener);
}
