// Copyright (c) 2022 NetEase, Inc. All rights reserved.
// Use of this source code is governed by a MIT license that can be
// found in the LICENSE file.

import 'package:nertc_core_platform_interface/nertc_core_platform_interface.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';
import 'package:nertc_core_platform_interface/method_channel/nertc_video_render_method_channel.dart';

abstract class NERtcVideoRenderPlatform extends PlatformInterface {
  static final Object _token = Object();

  NERtcVideoRenderPlatform() : super(token: _token);

  static NERtcVideoRenderPlatform _instance = MethodChannelNERtcVideoRender();

  static NERtcVideoRenderPlatform get instance => _instance;

  static set instance(NERtcVideoRenderPlatform instance) {
    PlatformInterface.verify(instance, _token);
    _instance = instance;
  }

  Future<int> createVideoRenderer();

  Future<int> setMirror(int textureId, bool mirror);

  Future<int> setupLocalVideoRenderer(int textureId);

  Future<int> setupRemoteVideoRenderer(int uid, int textureId);

  Future<int> setupLocalSubStreamVideoRenderer(int textureId);

  Future<int> setupRemoteSubStreamVideoRenderer(int uid, int textureId);

  Future<void> disposeVideoRenderer(int textureId);
}
