// Autogenerated from Pigeon (v9.2.5), do not edit directly.
// See also: https://pub.dev/packages/pigeon
// ignore_for_file: public_member_api_docs, non_constant_identifier_names, avoid_as, unused_import, unnecessary_parenthesis, prefer_null_aware_operators, omit_local_variable_types, unused_shown_name, unnecessary_import

import 'dart:async';
import 'dart:typed_data' show Float64List, Int32List, Int64List, Uint8List;

import 'package:flutter/foundation.dart' show ReadBuffer, WriteBuffer;
import 'package:flutter/services.dart';

/// 视频水印类型
enum NERtcVideoWatermarkType {
  ///图片
  kNERtcVideoWatermarkTypeImage,

  ///文字
  kNERtcVideoWatermarkTypeText,

  ///时间戳
  kNERtcVideoWatermarkTypeTimeStamp,
}

///摄像头额外旋转信息
enum NERtcCaptureExtraRotation {
  ///（默认）没有额外的旋转信息，直接使用系统旋转参数处理
  kNERtcCaptureExtraRotationDefault,

  ///在系统旋转信息的基础上，额外顺时针旋转90度
  kNERtcCaptureExtraRotationClockWise90,

  ///在系统旋转信息的基础上，额外旋转180度
  kNERtcCaptureExtraRotation180,

  ///在系统旋转信息的基础上，额外逆时针旋转90度
  kNERtcCaptureExtraRotationAntiClockWise90,
}

/// onUserJoined 回调的一些可选信息
class NERtcUserJoinExtraInfo {
  NERtcUserJoinExtraInfo({
    required this.customInfo,
  });

  ///自定义信息， 来源于远端用户joinChannel时填的 [NERtcJoinChannelOptions.customInfo]参数，默认为空字符串。
  String customInfo;

  Object encode() {
    return <Object?>[
      customInfo,
    ];
  }

  static NERtcUserJoinExtraInfo decode(Object result) {
    result as List<Object?>;
    return NERtcUserJoinExtraInfo(
      customInfo: result[0]! as String,
    );
  }
}

/// onUserLeave 回调的一些可选信息
class NERtcUserLeaveExtraInfo {
  NERtcUserLeaveExtraInfo({
    required this.customInfo,
  });

  /// 自定义信息, 来源于远端用户joinChannel时填的 [NERtcJoinChannelOptions.customInfo]参数，默认为空字符串。
  String customInfo;

  Object encode() {
    return <Object?>[
      customInfo,
    ];
  }

  static NERtcUserLeaveExtraInfo decode(Object result) {
    result as List<Object?>;
    return NERtcUserLeaveExtraInfo(
      customInfo: result[0]! as String,
    );
  }
}

class UserJoinedEvent {
  UserJoinedEvent({
    required this.uid,
    this.joinExtraInfo,
  });

  int uid;

  NERtcUserJoinExtraInfo? joinExtraInfo;

  Object encode() {
    return <Object?>[
      uid,
      joinExtraInfo?.encode(),
    ];
  }

  static UserJoinedEvent decode(Object result) {
    result as List<Object?>;
    return UserJoinedEvent(
      uid: result[0]! as int,
      joinExtraInfo: result[1] != null
          ? NERtcUserJoinExtraInfo.decode(result[1]! as List<Object?>)
          : null,
    );
  }
}

class UserLeaveEvent {
  UserLeaveEvent({
    required this.uid,
    required this.reason,
    this.leaveExtraInfo,
  });

  int uid;

  int reason;

  NERtcUserLeaveExtraInfo? leaveExtraInfo;

  Object encode() {
    return <Object?>[
      uid,
      reason,
      leaveExtraInfo?.encode(),
    ];
  }

  static UserLeaveEvent decode(Object result) {
    result as List<Object?>;
    return UserLeaveEvent(
      uid: result[0]! as int,
      reason: result[1]! as int,
      leaveExtraInfo: result[2] != null
          ? NERtcUserLeaveExtraInfo.decode(result[2]! as List<Object?>)
          : null,
    );
  }
}

class UserVideoMuteEvent {
  UserVideoMuteEvent({
    required this.uid,
    required this.muted,
    this.streamType,
  });

  int uid;

  bool muted;

  int? streamType;

  Object encode() {
    return <Object?>[
      uid,
      muted,
      streamType,
    ];
  }

  static UserVideoMuteEvent decode(Object result) {
    result as List<Object?>;
    return UserVideoMuteEvent(
      uid: result[0]! as int,
      muted: result[1]! as bool,
      streamType: result[2] as int?,
    );
  }
}

class FirstVideoDataReceivedEvent {
  FirstVideoDataReceivedEvent({
    required this.uid,
    this.streamType,
  });

  int uid;

  int? streamType;

  Object encode() {
    return <Object?>[
      uid,
      streamType,
    ];
  }

  static FirstVideoDataReceivedEvent decode(Object result) {
    result as List<Object?>;
    return FirstVideoDataReceivedEvent(
      uid: result[0]! as int,
      streamType: result[1] as int?,
    );
  }
}

class FirstVideoFrameDecodedEvent {
  FirstVideoFrameDecodedEvent({
    required this.uid,
    required this.width,
    required this.height,
    this.streamType,
  });

  int uid;

  int width;

  int height;

  int? streamType;

  Object encode() {
    return <Object?>[
      uid,
      width,
      height,
      streamType,
    ];
  }

  static FirstVideoFrameDecodedEvent decode(Object result) {
    result as List<Object?>;
    return FirstVideoFrameDecodedEvent(
      uid: result[0]! as int,
      width: result[1]! as int,
      height: result[2]! as int,
      streamType: result[3] as int?,
    );
  }
}

class VirtualBackgroundSourceEnabledEvent {
  VirtualBackgroundSourceEnabledEvent({
    required this.enabled,
    required this.reason,
  });

  bool enabled;

  int reason;

  Object encode() {
    return <Object?>[
      enabled,
      reason,
    ];
  }

  static VirtualBackgroundSourceEnabledEvent decode(Object result) {
    result as List<Object?>;
    return VirtualBackgroundSourceEnabledEvent(
      enabled: result[0]! as bool,
      reason: result[1]! as int,
    );
  }
}

class AudioVolumeInfo {
  AudioVolumeInfo({
    required this.uid,
    required this.volume,
    required this.subStreamVolume,
  });

  int uid;

  int volume;

  int subStreamVolume;

  Object encode() {
    return <Object?>[
      uid,
      volume,
      subStreamVolume,
    ];
  }

  static AudioVolumeInfo decode(Object result) {
    result as List<Object?>;
    return AudioVolumeInfo(
      uid: result[0]! as int,
      volume: result[1]! as int,
      subStreamVolume: result[2]! as int,
    );
  }
}

class RemoteAudioVolumeIndicationEvent {
  RemoteAudioVolumeIndicationEvent({
    this.volumeList,
    required this.totalVolume,
  });

  List<AudioVolumeInfo?>? volumeList;

  int totalVolume;

  Object encode() {
    return <Object?>[
      volumeList,
      totalVolume,
    ];
  }

  static RemoteAudioVolumeIndicationEvent decode(Object result) {
    result as List<Object?>;
    return RemoteAudioVolumeIndicationEvent(
      volumeList: (result[0] as List<Object?>?)?.cast<AudioVolumeInfo?>(),
      totalVolume: result[1]! as int,
    );
  }
}

///上下行 Last mile 网络质量探测结果
class NERtcLastmileProbeResult {
  NERtcLastmileProbeResult({
    required this.state,
    required this.rtt,
    required this.uplinkReport,
    required this.downlinkReport,
  });

  ///Last mile 质量探测结果的状态, 详细参数见 [NERtcLastmileProbeResultState]
  int state;

  ///往返时延，单位为毫秒(ms)
  int rtt;

  ///上行网络质量报告
  NERtcLastmileProbeOneWayResult uplinkReport;

  ///下行网络质量报告
  NERtcLastmileProbeOneWayResult downlinkReport;

  Object encode() {
    return <Object?>[
      state,
      rtt,
      uplinkReport.encode(),
      downlinkReport.encode(),
    ];
  }

  static NERtcLastmileProbeResult decode(Object result) {
    result as List<Object?>;
    return NERtcLastmileProbeResult(
      state: result[0]! as int,
      rtt: result[1]! as int,
      uplinkReport:
          NERtcLastmileProbeOneWayResult.decode(result[2]! as List<Object?>),
      downlinkReport:
          NERtcLastmileProbeOneWayResult.decode(result[3]! as List<Object?>),
    );
  }
}

///单向 Last mile 网络质量探测结果报告
class NERtcLastmileProbeOneWayResult {
  NERtcLastmileProbeOneWayResult({
    required this.packetLossRate,
    required this.jitter,
    required this.availableBandwidth,
  });

  ///丢包率
  int packetLossRate;

  ///网络抖动，单位为毫秒 (ms)
  int jitter;

  ///可用网络带宽预估，单位为 bps
  int availableBandwidth;

  Object encode() {
    return <Object?>[
      packetLossRate,
      jitter,
      availableBandwidth,
    ];
  }

  static NERtcLastmileProbeOneWayResult decode(Object result) {
    result as List<Object?>;
    return NERtcLastmileProbeOneWayResult(
      packetLossRate: result[0]! as int,
      jitter: result[1]! as int,
      availableBandwidth: result[2]! as int,
    );
  }
}

class RtcServerAddresses {
  RtcServerAddresses({
    this.valid,
    this.channelServer,
    this.statisticsServer,
    this.roomServer,
    this.compatServer,
    this.nosLbsServer,
    this.nosUploadSever,
    this.nosTokenServer,
    this.sdkConfigServer,
    this.cloudProxyServer,
    this.webSocketProxyServer,
    this.quicProxyServer,
    this.mediaProxyServer,
    this.statisticsDispatchServer,
    this.statisticsBackupServer,
    this.useIPv6,
  });

  bool? valid;

  String? channelServer;

  String? statisticsServer;

  String? roomServer;

  String? compatServer;

  String? nosLbsServer;

  String? nosUploadSever;

  String? nosTokenServer;

  String? sdkConfigServer;

  String? cloudProxyServer;

  String? webSocketProxyServer;

  String? quicProxyServer;

  String? mediaProxyServer;

  String? statisticsDispatchServer;

  String? statisticsBackupServer;

  bool? useIPv6;

  Object encode() {
    return <Object?>[
      valid,
      channelServer,
      statisticsServer,
      roomServer,
      compatServer,
      nosLbsServer,
      nosUploadSever,
      nosTokenServer,
      sdkConfigServer,
      cloudProxyServer,
      webSocketProxyServer,
      quicProxyServer,
      mediaProxyServer,
      statisticsDispatchServer,
      statisticsBackupServer,
      useIPv6,
    ];
  }

  static RtcServerAddresses decode(Object result) {
    result as List<Object?>;
    return RtcServerAddresses(
      valid: result[0] as bool?,
      channelServer: result[1] as String?,
      statisticsServer: result[2] as String?,
      roomServer: result[3] as String?,
      compatServer: result[4] as String?,
      nosLbsServer: result[5] as String?,
      nosUploadSever: result[6] as String?,
      nosTokenServer: result[7] as String?,
      sdkConfigServer: result[8] as String?,
      cloudProxyServer: result[9] as String?,
      webSocketProxyServer: result[10] as String?,
      quicProxyServer: result[11] as String?,
      mediaProxyServer: result[12] as String?,
      statisticsDispatchServer: result[13] as String?,
      statisticsBackupServer: result[14] as String?,
      useIPv6: result[15] as bool?,
    );
  }
}

class CreateEngineRequest {
  CreateEngineRequest({
    this.appKey,
    this.logDir,
    this.serverAddresses,
    this.logLevel,
    this.audioAutoSubscribe,
    this.videoAutoSubscribe,
    this.disableFirstJoinUserCreateChannel,
    this.audioDisableOverrideSpeakerOnReceiver,
    this.audioDisableSWAECOnHeadset,
    this.audioAINSEnabled,
    this.serverRecordAudio,
    this.serverRecordVideo,
    this.serverRecordMode,
    this.serverRecordSpeaker,
    this.publishSelfStream,
    this.videoCaptureObserverEnabled,
    this.videoEncodeMode,
    this.videoDecodeMode,
    this.videoSendMode,
    this.videoH265Enabled,
    this.mode1v1Enabled,
  });

  String? appKey;

  String? logDir;

  RtcServerAddresses? serverAddresses;

  int? logLevel;

  bool? audioAutoSubscribe;

  bool? videoAutoSubscribe;

  bool? disableFirstJoinUserCreateChannel;

  bool? audioDisableOverrideSpeakerOnReceiver;

  bool? audioDisableSWAECOnHeadset;

  bool? audioAINSEnabled;

  bool? serverRecordAudio;

  bool? serverRecordVideo;

  int? serverRecordMode;

  bool? serverRecordSpeaker;

  bool? publishSelfStream;

  bool? videoCaptureObserverEnabled;

  int? videoEncodeMode;

  int? videoDecodeMode;

  int? videoSendMode;

  bool? videoH265Enabled;

  bool? mode1v1Enabled;

  Object encode() {
    return <Object?>[
      appKey,
      logDir,
      serverAddresses?.encode(),
      logLevel,
      audioAutoSubscribe,
      videoAutoSubscribe,
      disableFirstJoinUserCreateChannel,
      audioDisableOverrideSpeakerOnReceiver,
      audioDisableSWAECOnHeadset,
      audioAINSEnabled,
      serverRecordAudio,
      serverRecordVideo,
      serverRecordMode,
      serverRecordSpeaker,
      publishSelfStream,
      videoCaptureObserverEnabled,
      videoEncodeMode,
      videoDecodeMode,
      videoSendMode,
      videoH265Enabled,
      mode1v1Enabled,
    ];
  }

  static CreateEngineRequest decode(Object result) {
    result as List<Object?>;
    return CreateEngineRequest(
      appKey: result[0] as String?,
      logDir: result[1] as String?,
      serverAddresses: result[2] != null
          ? RtcServerAddresses.decode(result[2]! as List<Object?>)
          : null,
      logLevel: result[3] as int?,
      audioAutoSubscribe: result[4] as bool?,
      videoAutoSubscribe: result[5] as bool?,
      disableFirstJoinUserCreateChannel: result[6] as bool?,
      audioDisableOverrideSpeakerOnReceiver: result[7] as bool?,
      audioDisableSWAECOnHeadset: result[8] as bool?,
      audioAINSEnabled: result[9] as bool?,
      serverRecordAudio: result[10] as bool?,
      serverRecordVideo: result[11] as bool?,
      serverRecordMode: result[12] as int?,
      serverRecordSpeaker: result[13] as bool?,
      publishSelfStream: result[14] as bool?,
      videoCaptureObserverEnabled: result[15] as bool?,
      videoEncodeMode: result[16] as int?,
      videoDecodeMode: result[17] as int?,
      videoSendMode: result[18] as int?,
      videoH265Enabled: result[19] as bool?,
      mode1v1Enabled: result[20] as bool?,
    );
  }
}

class JoinChannelOptions {
  JoinChannelOptions({
    this.customInfo,
    this.permissionKey,
  });

  String? customInfo;

  String? permissionKey;

  Object encode() {
    return <Object?>[
      customInfo,
      permissionKey,
    ];
  }

  static JoinChannelOptions decode(Object result) {
    result as List<Object?>;
    return JoinChannelOptions(
      customInfo: result[0] as String?,
      permissionKey: result[1] as String?,
    );
  }
}

class JoinChannelRequest {
  JoinChannelRequest({
    this.token,
    required this.channelName,
    required this.uid,
    this.channelOptions,
  });

  String? token;

  String channelName;

  int uid;

  JoinChannelOptions? channelOptions;

  Object encode() {
    return <Object?>[
      token,
      channelName,
      uid,
      channelOptions?.encode(),
    ];
  }

  static JoinChannelRequest decode(Object result) {
    result as List<Object?>;
    return JoinChannelRequest(
      token: result[0] as String?,
      channelName: result[1]! as String,
      uid: result[2]! as int,
      channelOptions: result[3] != null
          ? JoinChannelOptions.decode(result[3]! as List<Object?>)
          : null,
    );
  }
}

class SubscribeRemoteAudioRequest {
  SubscribeRemoteAudioRequest({
    this.uid,
    this.subscribe,
  });

  int? uid;

  bool? subscribe;

  Object encode() {
    return <Object?>[
      uid,
      subscribe,
    ];
  }

  static SubscribeRemoteAudioRequest decode(Object result) {
    result as List<Object?>;
    return SubscribeRemoteAudioRequest(
      uid: result[0] as int?,
      subscribe: result[1] as bool?,
    );
  }
}

class EnableLocalVideoRequest {
  EnableLocalVideoRequest({
    this.enable,
    this.streamType,
  });

  bool? enable;

  int? streamType;

  Object encode() {
    return <Object?>[
      enable,
      streamType,
    ];
  }

  static EnableLocalVideoRequest decode(Object result) {
    result as List<Object?>;
    return EnableLocalVideoRequest(
      enable: result[0] as bool?,
      streamType: result[1] as int?,
    );
  }
}

class SetAudioProfileRequest {
  SetAudioProfileRequest({
    this.profile,
    this.scenario,
  });

  int? profile;

  int? scenario;

  Object encode() {
    return <Object?>[
      profile,
      scenario,
    ];
  }

  static SetAudioProfileRequest decode(Object result) {
    result as List<Object?>;
    return SetAudioProfileRequest(
      profile: result[0] as int?,
      scenario: result[1] as int?,
    );
  }
}

class SetLocalVideoConfigRequest {
  SetLocalVideoConfigRequest({
    this.videoProfile,
    this.videoCropMode,
    this.frontCamera,
    this.frameRate,
    this.minFrameRate,
    this.bitrate,
    this.minBitrate,
    this.degradationPrefer,
    this.width,
    this.height,
    this.cameraType,
    this.mirrorMode,
    this.orientationMode,
    this.streamType,
  });

  int? videoProfile;

  int? videoCropMode;

  bool? frontCamera;

  int? frameRate;

  int? minFrameRate;

  int? bitrate;

  int? minBitrate;

  int? degradationPrefer;

  int? width;

  int? height;

  int? cameraType;

  int? mirrorMode;

  int? orientationMode;

  int? streamType;

  Object encode() {
    return <Object?>[
      videoProfile,
      videoCropMode,
      frontCamera,
      frameRate,
      minFrameRate,
      bitrate,
      minBitrate,
      degradationPrefer,
      width,
      height,
      cameraType,
      mirrorMode,
      orientationMode,
      streamType,
    ];
  }

  static SetLocalVideoConfigRequest decode(Object result) {
    result as List<Object?>;
    return SetLocalVideoConfigRequest(
      videoProfile: result[0] as int?,
      videoCropMode: result[1] as int?,
      frontCamera: result[2] as bool?,
      frameRate: result[3] as int?,
      minFrameRate: result[4] as int?,
      bitrate: result[5] as int?,
      minBitrate: result[6] as int?,
      degradationPrefer: result[7] as int?,
      width: result[8] as int?,
      height: result[9] as int?,
      cameraType: result[10] as int?,
      mirrorMode: result[11] as int?,
      orientationMode: result[12] as int?,
      streamType: result[13] as int?,
    );
  }
}

/// 摄像头采集配置
class SetCameraCaptureConfigRequest {
  SetCameraCaptureConfigRequest({
    this.extraRotation,
    this.captureWidth,
    this.captureHeight,
    this.streamType,
  });

  /// 设置摄像头的额外旋转信息
  NERtcCaptureExtraRotation? extraRotation;

  /// 本地采集的视频宽度，单位为 px。
  ///
  /// 视频编码分辨率以宽 x 高表示，用于设置视频编码分辨率，以衡量编码质量。
  ///
  /// captureWidth 表示视频帧在横轴上的像素，即自定义宽。
  int? captureWidth;

  /// 本地采集的视频宽度，单位为 px。
  ///
  /// 视频编码分辨率以宽 x 高表示，用于设置视频编码分辨率，以衡量编码质量。
  ///
  /// captureHeight 表示视频帧在横轴上的像素，即自定义高。
  int? captureHeight;

  /// 视频流类型
  int? streamType;

  Object encode() {
    return <Object?>[
      extraRotation?.index,
      captureWidth,
      captureHeight,
      streamType,
    ];
  }

  static SetCameraCaptureConfigRequest decode(Object result) {
    result as List<Object?>;
    return SetCameraCaptureConfigRequest(
      extraRotation: result[0] != null
          ? NERtcCaptureExtraRotation.values[result[0]! as int]
          : null,
      captureWidth: result[1] as int?,
      captureHeight: result[2] as int?,
      streamType: result[3] as int?,
    );
  }
}

class StartorStopVideoPreviewRequest {
  StartorStopVideoPreviewRequest({
    this.streamType,
  });

  int? streamType;

  Object encode() {
    return <Object?>[
      streamType,
    ];
  }

  static StartorStopVideoPreviewRequest decode(Object result) {
    result as List<Object?>;
    return StartorStopVideoPreviewRequest(
      streamType: result[0] as int?,
    );
  }
}

class StartScreenCaptureRequest {
  StartScreenCaptureRequest({
    this.contentPrefer,
    this.videoProfile,
    this.frameRate,
    this.minFrameRate,
    this.bitrate,
    this.minBitrate,
  });

  int? contentPrefer;

  int? videoProfile;

  int? frameRate;

  int? minFrameRate;

  int? bitrate;

  int? minBitrate;

  Object encode() {
    return <Object?>[
      contentPrefer,
      videoProfile,
      frameRate,
      minFrameRate,
      bitrate,
      minBitrate,
    ];
  }

  static StartScreenCaptureRequest decode(Object result) {
    result as List<Object?>;
    return StartScreenCaptureRequest(
      contentPrefer: result[0] as int?,
      videoProfile: result[1] as int?,
      frameRate: result[2] as int?,
      minFrameRate: result[3] as int?,
      bitrate: result[4] as int?,
      minBitrate: result[5] as int?,
    );
  }
}

class SubscribeRemoteVideoStreamRequest {
  SubscribeRemoteVideoStreamRequest({
    this.uid,
    this.streamType,
    this.subscribe,
  });

  int? uid;

  int? streamType;

  bool? subscribe;

  Object encode() {
    return <Object?>[
      uid,
      streamType,
      subscribe,
    ];
  }

  static SubscribeRemoteVideoStreamRequest decode(Object result) {
    result as List<Object?>;
    return SubscribeRemoteVideoStreamRequest(
      uid: result[0] as int?,
      streamType: result[1] as int?,
      subscribe: result[2] as bool?,
    );
  }
}

class SubscribeRemoteSubStreamVideoRequest {
  SubscribeRemoteSubStreamVideoRequest({
    this.uid,
    this.subscribe,
  });

  int? uid;

  bool? subscribe;

  Object encode() {
    return <Object?>[
      uid,
      subscribe,
    ];
  }

  static SubscribeRemoteSubStreamVideoRequest decode(Object result) {
    result as List<Object?>;
    return SubscribeRemoteSubStreamVideoRequest(
      uid: result[0] as int?,
      subscribe: result[1] as bool?,
    );
  }
}

class EnableAudioVolumeIndicationRequest {
  EnableAudioVolumeIndicationRequest({
    this.enable,
    this.interval,
    this.vad,
  });

  bool? enable;

  int? interval;

  bool? vad;

  Object encode() {
    return <Object?>[
      enable,
      interval,
      vad,
    ];
  }

  static EnableAudioVolumeIndicationRequest decode(Object result) {
    result as List<Object?>;
    return EnableAudioVolumeIndicationRequest(
      enable: result[0] as bool?,
      interval: result[1] as int?,
      vad: result[2] as bool?,
    );
  }
}

class SubscribeRemoteSubStreamAudioRequest {
  SubscribeRemoteSubStreamAudioRequest({
    this.subscribe,
    this.uid,
  });

  bool? subscribe;

  int? uid;

  Object encode() {
    return <Object?>[
      subscribe,
      uid,
    ];
  }

  static SubscribeRemoteSubStreamAudioRequest decode(Object result) {
    result as List<Object?>;
    return SubscribeRemoteSubStreamAudioRequest(
      subscribe: result[0] as bool?,
      uid: result[1] as int?,
    );
  }
}

class SetAudioSubscribeOnlyByRequest {
  SetAudioSubscribeOnlyByRequest({
    this.uidArray,
  });

  List<int?>? uidArray;

  Object encode() {
    return <Object?>[
      uidArray,
    ];
  }

  static SetAudioSubscribeOnlyByRequest decode(Object result) {
    result as List<Object?>;
    return SetAudioSubscribeOnlyByRequest(
      uidArray: (result[0] as List<Object?>?)?.cast<int?>(),
    );
  }
}

class StartAudioMixingRequest {
  StartAudioMixingRequest({
    this.path,
    this.loopCount,
    this.sendEnabled,
    this.sendVolume,
    this.playbackEnabled,
    this.playbackVolume,
    this.startTimeStamp,
    this.sendWithAudioType,
    this.progressInterval,
  });

  String? path;

  int? loopCount;

  bool? sendEnabled;

  int? sendVolume;

  bool? playbackEnabled;

  int? playbackVolume;

  int? startTimeStamp;

  int? sendWithAudioType;

  int? progressInterval;

  Object encode() {
    return <Object?>[
      path,
      loopCount,
      sendEnabled,
      sendVolume,
      playbackEnabled,
      playbackVolume,
      startTimeStamp,
      sendWithAudioType,
      progressInterval,
    ];
  }

  static StartAudioMixingRequest decode(Object result) {
    result as List<Object?>;
    return StartAudioMixingRequest(
      path: result[0] as String?,
      loopCount: result[1] as int?,
      sendEnabled: result[2] as bool?,
      sendVolume: result[3] as int?,
      playbackEnabled: result[4] as bool?,
      playbackVolume: result[5] as int?,
      startTimeStamp: result[6] as int?,
      sendWithAudioType: result[7] as int?,
      progressInterval: result[8] as int?,
    );
  }
}

class PlayEffectRequest {
  PlayEffectRequest({
    this.effectId,
    this.path,
    this.loopCount,
    this.sendEnabled,
    this.sendVolume,
    this.playbackEnabled,
    this.playbackVolume,
    this.startTimestamp,
    this.sendWithAudioType,
    this.progressInterval,
  });

  int? effectId;

  String? path;

  int? loopCount;

  bool? sendEnabled;

  int? sendVolume;

  bool? playbackEnabled;

  int? playbackVolume;

  int? startTimestamp;

  int? sendWithAudioType;

  int? progressInterval;

  Object encode() {
    return <Object?>[
      effectId,
      path,
      loopCount,
      sendEnabled,
      sendVolume,
      playbackEnabled,
      playbackVolume,
      startTimestamp,
      sendWithAudioType,
      progressInterval,
    ];
  }

  static PlayEffectRequest decode(Object result) {
    result as List<Object?>;
    return PlayEffectRequest(
      effectId: result[0] as int?,
      path: result[1] as String?,
      loopCount: result[2] as int?,
      sendEnabled: result[3] as bool?,
      sendVolume: result[4] as int?,
      playbackEnabled: result[5] as bool?,
      playbackVolume: result[6] as int?,
      startTimestamp: result[7] as int?,
      sendWithAudioType: result[8] as int?,
      progressInterval: result[9] as int?,
    );
  }
}

class SetCameraPositionRequest {
  SetCameraPositionRequest({
    this.x,
    this.y,
  });

  double? x;

  double? y;

  Object encode() {
    return <Object?>[
      x,
      y,
    ];
  }

  static SetCameraPositionRequest decode(Object result) {
    result as List<Object?>;
    return SetCameraPositionRequest(
      x: result[0] as double?,
      y: result[1] as double?,
    );
  }
}

class AddOrUpdateLiveStreamTaskRequest {
  AddOrUpdateLiveStreamTaskRequest({
    this.serial,
    this.taskId,
    this.url,
    this.serverRecordEnabled,
    this.liveMode,
    this.layoutWidth,
    this.layoutHeight,
    this.layoutBackgroundColor,
    this.layoutImageUrl,
    this.layoutImageX,
    this.layoutImageY,
    this.layoutImageWidth,
    this.layoutImageHeight,
    this.layoutUserTranscodingList,
  });

  int? serial;

  String? taskId;

  String? url;

  bool? serverRecordEnabled;

  int? liveMode;

  int? layoutWidth;

  int? layoutHeight;

  int? layoutBackgroundColor;

  String? layoutImageUrl;

  int? layoutImageX;

  int? layoutImageY;

  int? layoutImageWidth;

  int? layoutImageHeight;

  List<Object?>? layoutUserTranscodingList;

  Object encode() {
    return <Object?>[
      serial,
      taskId,
      url,
      serverRecordEnabled,
      liveMode,
      layoutWidth,
      layoutHeight,
      layoutBackgroundColor,
      layoutImageUrl,
      layoutImageX,
      layoutImageY,
      layoutImageWidth,
      layoutImageHeight,
      layoutUserTranscodingList,
    ];
  }

  static AddOrUpdateLiveStreamTaskRequest decode(Object result) {
    result as List<Object?>;
    return AddOrUpdateLiveStreamTaskRequest(
      serial: result[0] as int?,
      taskId: result[1] as String?,
      url: result[2] as String?,
      serverRecordEnabled: result[3] as bool?,
      liveMode: result[4] as int?,
      layoutWidth: result[5] as int?,
      layoutHeight: result[6] as int?,
      layoutBackgroundColor: result[7] as int?,
      layoutImageUrl: result[8] as String?,
      layoutImageX: result[9] as int?,
      layoutImageY: result[10] as int?,
      layoutImageWidth: result[11] as int?,
      layoutImageHeight: result[12] as int?,
      layoutUserTranscodingList: result[13] as List<Object?>?,
    );
  }
}

class DeleteLiveStreamTaskRequest {
  DeleteLiveStreamTaskRequest({
    this.serial,
    this.taskId,
  });

  int? serial;

  String? taskId;

  Object encode() {
    return <Object?>[
      serial,
      taskId,
    ];
  }

  static DeleteLiveStreamTaskRequest decode(Object result) {
    result as List<Object?>;
    return DeleteLiveStreamTaskRequest(
      serial: result[0] as int?,
      taskId: result[1] as String?,
    );
  }
}

class SendSEIMsgRequest {
  SendSEIMsgRequest({
    this.seiMsg,
    this.streamType,
  });

  String? seiMsg;

  int? streamType;

  Object encode() {
    return <Object?>[
      seiMsg,
      streamType,
    ];
  }

  static SendSEIMsgRequest decode(Object result) {
    result as List<Object?>;
    return SendSEIMsgRequest(
      seiMsg: result[0] as String?,
      streamType: result[1] as int?,
    );
  }
}

class SetLocalVoiceEqualizationRequest {
  SetLocalVoiceEqualizationRequest({
    this.bandFrequency,
    this.bandGain,
  });

  int? bandFrequency;

  int? bandGain;

  Object encode() {
    return <Object?>[
      bandFrequency,
      bandGain,
    ];
  }

  static SetLocalVoiceEqualizationRequest decode(Object result) {
    result as List<Object?>;
    return SetLocalVoiceEqualizationRequest(
      bandFrequency: result[0] as int?,
      bandGain: result[1] as int?,
    );
  }
}

class SwitchChannelRequest {
  SwitchChannelRequest({
    this.token,
    this.channelName,
    this.channelOptions,
  });

  String? token;

  String? channelName;

  JoinChannelOptions? channelOptions;

  Object encode() {
    return <Object?>[
      token,
      channelName,
      channelOptions?.encode(),
    ];
  }

  static SwitchChannelRequest decode(Object result) {
    result as List<Object?>;
    return SwitchChannelRequest(
      token: result[0] as String?,
      channelName: result[1] as String?,
      channelOptions: result[2] != null
          ? JoinChannelOptions.decode(result[2]! as List<Object?>)
          : null,
    );
  }
}

class StartAudioRecordingRequest {
  StartAudioRecordingRequest({
    this.filePath,
    this.sampleRate,
    this.quality,
  });

  String? filePath;

  int? sampleRate;

  int? quality;

  Object encode() {
    return <Object?>[
      filePath,
      sampleRate,
      quality,
    ];
  }

  static StartAudioRecordingRequest decode(Object result) {
    result as List<Object?>;
    return StartAudioRecordingRequest(
      filePath: result[0] as String?,
      sampleRate: result[1] as int?,
      quality: result[2] as int?,
    );
  }
}

class AudioRecordingConfigurationRequest {
  AudioRecordingConfigurationRequest({
    this.filePath,
    this.sampleRate,
    this.quality,
    this.position,
    this.cycleTime,
  });

  String? filePath;

  int? sampleRate;

  int? quality;

  int? position;

  int? cycleTime;

  Object encode() {
    return <Object?>[
      filePath,
      sampleRate,
      quality,
      position,
      cycleTime,
    ];
  }

  static AudioRecordingConfigurationRequest decode(Object result) {
    result as List<Object?>;
    return AudioRecordingConfigurationRequest(
      filePath: result[0] as String?,
      sampleRate: result[1] as int?,
      quality: result[2] as int?,
      position: result[3] as int?,
      cycleTime: result[4] as int?,
    );
  }
}

class SetLocalMediaPriorityRequest {
  SetLocalMediaPriorityRequest({
    this.priority,
    this.isPreemptive,
  });

  int? priority;

  bool? isPreemptive;

  Object encode() {
    return <Object?>[
      priority,
      isPreemptive,
    ];
  }

  static SetLocalMediaPriorityRequest decode(Object result) {
    result as List<Object?>;
    return SetLocalMediaPriorityRequest(
      priority: result[0] as int?,
      isPreemptive: result[1] as bool?,
    );
  }
}

class StartOrUpdateChannelMediaRelayRequest {
  StartOrUpdateChannelMediaRelayRequest({
    this.sourceMediaInfo,
    this.destMediaInfo,
  });

  Map<Object?, Object?>? sourceMediaInfo;

  Map<Object?, Map<Object?, Object?>?>? destMediaInfo;

  Object encode() {
    return <Object?>[
      sourceMediaInfo,
      destMediaInfo,
    ];
  }

  static StartOrUpdateChannelMediaRelayRequest decode(Object result) {
    result as List<Object?>;
    return StartOrUpdateChannelMediaRelayRequest(
      sourceMediaInfo:
          (result[0] as Map<Object?, Object?>?)?.cast<Object?, Object?>(),
      destMediaInfo: (result[1] as Map<Object?, Object?>?)
          ?.cast<Object?, Map<Object?, Object?>?>(),
    );
  }
}

class AdjustUserPlaybackSignalVolumeRequest {
  AdjustUserPlaybackSignalVolumeRequest({
    this.uid,
    this.volume,
  });

  int? uid;

  int? volume;

  Object encode() {
    return <Object?>[
      uid,
      volume,
    ];
  }

  static AdjustUserPlaybackSignalVolumeRequest decode(Object result) {
    result as List<Object?>;
    return AdjustUserPlaybackSignalVolumeRequest(
      uid: result[0] as int?,
      volume: result[1] as int?,
    );
  }
}

class EnableEncryptionRequest {
  EnableEncryptionRequest({
    this.key,
    this.mode,
    this.enable,
  });

  String? key;

  int? mode;

  bool? enable;

  Object encode() {
    return <Object?>[
      key,
      mode,
      enable,
    ];
  }

  static EnableEncryptionRequest decode(Object result) {
    result as List<Object?>;
    return EnableEncryptionRequest(
      key: result[0] as String?,
      mode: result[1] as int?,
      enable: result[2] as bool?,
    );
  }
}

class SetLocalVoiceReverbParamRequest {
  SetLocalVoiceReverbParamRequest({
    this.wetGain,
    this.dryGain,
    this.damping,
    this.roomSize,
    this.decayTime,
    this.preDelay,
  });

  double? wetGain;

  double? dryGain;

  double? damping;

  double? roomSize;

  double? decayTime;

  double? preDelay;

  Object encode() {
    return <Object?>[
      wetGain,
      dryGain,
      damping,
      roomSize,
      decayTime,
      preDelay,
    ];
  }

  static SetLocalVoiceReverbParamRequest decode(Object result) {
    result as List<Object?>;
    return SetLocalVoiceReverbParamRequest(
      wetGain: result[0] as double?,
      dryGain: result[1] as double?,
      damping: result[2] as double?,
      roomSize: result[3] as double?,
      decayTime: result[4] as double?,
      preDelay: result[5] as double?,
    );
  }
}

class ReportCustomEventRequest {
  ReportCustomEventRequest({
    this.eventName,
    this.customIdentify,
    this.param,
  });

  String? eventName;

  String? customIdentify;

  Map<String?, Object?>? param;

  Object encode() {
    return <Object?>[
      eventName,
      customIdentify,
      param,
    ];
  }

  static ReportCustomEventRequest decode(Object result) {
    result as List<Object?>;
    return ReportCustomEventRequest(
      eventName: result[0] as String?,
      customIdentify: result[1] as String?,
      param: (result[2] as Map<Object?, Object?>?)?.cast<String?, Object?>(),
    );
  }
}

class StartLastmileProbeTestRequest {
  StartLastmileProbeTestRequest({
    this.probeUplink,
    this.probeDownlink,
    this.expectedUplinkBitrate,
    this.expectedDownlinkBitrate,
  });

  bool? probeUplink;

  bool? probeDownlink;

  int? expectedUplinkBitrate;

  int? expectedDownlinkBitrate;

  Object encode() {
    return <Object?>[
      probeUplink,
      probeDownlink,
      expectedUplinkBitrate,
      expectedDownlinkBitrate,
    ];
  }

  static StartLastmileProbeTestRequest decode(Object result) {
    result as List<Object?>;
    return StartLastmileProbeTestRequest(
      probeUplink: result[0] as bool?,
      probeDownlink: result[1] as bool?,
      expectedUplinkBitrate: result[2] as int?,
      expectedDownlinkBitrate: result[3] as int?,
    );
  }
}

/// 顶点坐标
class CGPoint {
  CGPoint({
    required this.x,
    required this.y,
  });

  /// x 的 取值范围是 &#91; 0-1 &#93;
  double x;

  /// y 的 取值范围是 &#91; 0-1 &#93;
  double y;

  Object encode() {
    return <Object?>[
      x,
      y,
    ];
  }

  static CGPoint decode(Object result) {
    result as List<Object?>;
    return CGPoint(
      x: result[0]! as double,
      y: result[1]! as double,
    );
  }
}

class SetVideoCorrectionConfigRequest {
  SetVideoCorrectionConfigRequest({
    this.topLeft,
    this.topRight,
    this.bottomLeft,
    this.bottomRight,
    this.canvasWidth,
    this.canvasHeight,
    this.enableMirror,
  });

  CGPoint? topLeft;

  CGPoint? topRight;

  CGPoint? bottomLeft;

  CGPoint? bottomRight;

  double? canvasWidth;

  double? canvasHeight;

  bool? enableMirror;

  Object encode() {
    return <Object?>[
      topLeft?.encode(),
      topRight?.encode(),
      bottomLeft?.encode(),
      bottomRight?.encode(),
      canvasWidth,
      canvasHeight,
      enableMirror,
    ];
  }

  static SetVideoCorrectionConfigRequest decode(Object result) {
    result as List<Object?>;
    return SetVideoCorrectionConfigRequest(
      topLeft: result[0] != null
          ? CGPoint.decode(result[0]! as List<Object?>)
          : null,
      topRight: result[1] != null
          ? CGPoint.decode(result[1]! as List<Object?>)
          : null,
      bottomLeft: result[2] != null
          ? CGPoint.decode(result[2]! as List<Object?>)
          : null,
      bottomRight: result[3] != null
          ? CGPoint.decode(result[3]! as List<Object?>)
          : null,
      canvasWidth: result[4] as double?,
      canvasHeight: result[5] as double?,
      enableMirror: result[6] as bool?,
    );
  }
}

class EnableVirtualBackgroundRequest {
  EnableVirtualBackgroundRequest({
    this.enabled,
    this.backgroundSourceType,
    this.color,
    this.source,
    this.blur_degree,
  });

  bool? enabled;

  int? backgroundSourceType;

  int? color;

  String? source;

  int? blur_degree;

  Object encode() {
    return <Object?>[
      enabled,
      backgroundSourceType,
      color,
      source,
      blur_degree,
    ];
  }

  static EnableVirtualBackgroundRequest decode(Object result) {
    result as List<Object?>;
    return EnableVirtualBackgroundRequest(
      enabled: result[0] as bool?,
      backgroundSourceType: result[1] as int?,
      color: result[2] as int?,
      source: result[3] as String?,
      blur_degree: result[4] as int?,
    );
  }
}

class SetRemoteHighPriorityAudioStreamRequest {
  SetRemoteHighPriorityAudioStreamRequest({
    this.enabled,
    this.uid,
    this.streamType,
  });

  bool? enabled;

  int? uid;

  int? streamType;

  Object encode() {
    return <Object?>[
      enabled,
      uid,
      streamType,
    ];
  }

  static SetRemoteHighPriorityAudioStreamRequest decode(Object result) {
    result as List<Object?>;
    return SetRemoteHighPriorityAudioStreamRequest(
      enabled: result[0] as bool?,
      uid: result[1] as int?,
      streamType: result[2] as int?,
    );
  }
}

class VideoWatermarkImageConfig {
  VideoWatermarkImageConfig({
    this.wmAlpha,
    this.wmWidth,
    this.wmHeight,
    this.offsetX,
    this.offsetY,
    this.imagePaths,
    this.fps,
    this.loop,
  });

  double? wmAlpha;

  int? wmWidth;

  int? wmHeight;

  int? offsetX;

  int? offsetY;

  List<String?>? imagePaths;

  int? fps;

  bool? loop;

  Object encode() {
    return <Object?>[
      wmAlpha,
      wmWidth,
      wmHeight,
      offsetX,
      offsetY,
      imagePaths,
      fps,
      loop,
    ];
  }

  static VideoWatermarkImageConfig decode(Object result) {
    result as List<Object?>;
    return VideoWatermarkImageConfig(
      wmAlpha: result[0] as double?,
      wmWidth: result[1] as int?,
      wmHeight: result[2] as int?,
      offsetX: result[3] as int?,
      offsetY: result[4] as int?,
      imagePaths: (result[5] as List<Object?>?)?.cast<String?>(),
      fps: result[6] as int?,
      loop: result[7] as bool?,
    );
  }
}

class VideoWatermarkTextConfig {
  VideoWatermarkTextConfig({
    this.wmAlpha,
    this.wmWidth,
    this.wmHeight,
    this.offsetX,
    this.offsetY,
    this.wmColor,
    this.fontSize,
    this.fontColor,
    this.fontNameOrPath,
    this.content,
  });

  double? wmAlpha;

  int? wmWidth;

  int? wmHeight;

  int? offsetX;

  int? offsetY;

  int? wmColor;

  int? fontSize;

  int? fontColor;

  String? fontNameOrPath;

  String? content;

  Object encode() {
    return <Object?>[
      wmAlpha,
      wmWidth,
      wmHeight,
      offsetX,
      offsetY,
      wmColor,
      fontSize,
      fontColor,
      fontNameOrPath,
      content,
    ];
  }

  static VideoWatermarkTextConfig decode(Object result) {
    result as List<Object?>;
    return VideoWatermarkTextConfig(
      wmAlpha: result[0] as double?,
      wmWidth: result[1] as int?,
      wmHeight: result[2] as int?,
      offsetX: result[3] as int?,
      offsetY: result[4] as int?,
      wmColor: result[5] as int?,
      fontSize: result[6] as int?,
      fontColor: result[7] as int?,
      fontNameOrPath: result[8] as String?,
      content: result[9] as String?,
    );
  }
}

class VideoWatermarkTimestampConfig {
  VideoWatermarkTimestampConfig({
    this.wmAlpha,
    this.wmWidth,
    this.wmHeight,
    this.offsetX,
    this.offsetY,
    this.wmColor,
    this.fontSize,
    this.fontColor,
    this.fontNameOrPath,
  });

  double? wmAlpha;

  int? wmWidth;

  int? wmHeight;

  int? offsetX;

  int? offsetY;

  int? wmColor;

  int? fontSize;

  int? fontColor;

  String? fontNameOrPath;

  Object encode() {
    return <Object?>[
      wmAlpha,
      wmWidth,
      wmHeight,
      offsetX,
      offsetY,
      wmColor,
      fontSize,
      fontColor,
      fontNameOrPath,
    ];
  }

  static VideoWatermarkTimestampConfig decode(Object result) {
    result as List<Object?>;
    return VideoWatermarkTimestampConfig(
      wmAlpha: result[0] as double?,
      wmWidth: result[1] as int?,
      wmHeight: result[2] as int?,
      offsetX: result[3] as int?,
      offsetY: result[4] as int?,
      wmColor: result[5] as int?,
      fontSize: result[6] as int?,
      fontColor: result[7] as int?,
      fontNameOrPath: result[8] as String?,
    );
  }
}

///视频水印设置，目前支持三种类型的水印，但只能其中选择一种水印生效
class VideoWatermarkConfig {
  VideoWatermarkConfig({
    required this.WatermarkType,
    this.imageWatermark,
    this.textWatermark,
    this.timestampWatermark,
  });

  NERtcVideoWatermarkType WatermarkType;

  VideoWatermarkImageConfig? imageWatermark;

  VideoWatermarkTextConfig? textWatermark;

  VideoWatermarkTimestampConfig? timestampWatermark;

  Object encode() {
    return <Object?>[
      WatermarkType.index,
      imageWatermark?.encode(),
      textWatermark?.encode(),
      timestampWatermark?.encode(),
    ];
  }

  static VideoWatermarkConfig decode(Object result) {
    result as List<Object?>;
    return VideoWatermarkConfig(
      WatermarkType: NERtcVideoWatermarkType.values[result[0]! as int],
      imageWatermark: result[1] != null
          ? VideoWatermarkImageConfig.decode(result[1]! as List<Object?>)
          : null,
      textWatermark: result[2] != null
          ? VideoWatermarkTextConfig.decode(result[2]! as List<Object?>)
          : null,
      timestampWatermark: result[3] != null
          ? VideoWatermarkTimestampConfig.decode(result[3]! as List<Object?>)
          : null,
    );
  }
}

class SetLocalVideoWatermarkConfigsRequest {
  SetLocalVideoWatermarkConfigsRequest({
    required this.type,
    this.config,
  });

  int type;

  VideoWatermarkConfig? config;

  Object encode() {
    return <Object?>[
      type,
      config?.encode(),
    ];
  }

  static SetLocalVideoWatermarkConfigsRequest decode(Object result) {
    result as List<Object?>;
    return SetLocalVideoWatermarkConfigsRequest(
      type: result[0]! as int,
      config: result[1] != null
          ? VideoWatermarkConfig.decode(result[1]! as List<Object?>)
          : null,
    );
  }
}

/// NERtc 版本信息
class NERtcVersion {
  NERtcVersion({
    this.versionName,
    this.versionCode,
    this.buildType,
    this.buildDate,
    this.buildRevision,
    this.buildHost,
    this.serverEnv,
    this.buildBranch,
    this.engineRevision,
  });

  String? versionName;

  int? versionCode;

  String? buildType;

  String? buildDate;

  String? buildRevision;

  String? buildHost;

  String? serverEnv;

  String? buildBranch;

  String? engineRevision;

  Object encode() {
    return <Object?>[
      versionName,
      versionCode,
      buildType,
      buildDate,
      buildRevision,
      buildHost,
      serverEnv,
      buildBranch,
      engineRevision,
    ];
  }

  static NERtcVersion decode(Object result) {
    result as List<Object?>;
    return NERtcVersion(
      versionName: result[0] as String?,
      versionCode: result[1] as int?,
      buildType: result[2] as String?,
      buildDate: result[3] as String?,
      buildRevision: result[4] as String?,
      buildHost: result[5] as String?,
      serverEnv: result[6] as String?,
      buildBranch: result[7] as String?,
      engineRevision: result[8] as String?,
    );
  }
}

class VideoFrame {
  VideoFrame({
    this.width,
    this.height,
    this.rotation,
    this.format,
    this.timeStamp,
    this.data,
    this.strideY,
    this.strideU,
    this.strideV,
    this.textureId,
    this.transformMatrix,
  });

  int? width;

  int? height;

  int? rotation;

  int? format;

  int? timeStamp;

  Uint8List? data;

  int? strideY;

  int? strideU;

  int? strideV;

  int? textureId;

  List<double?>? transformMatrix;

  Object encode() {
    return <Object?>[
      width,
      height,
      rotation,
      format,
      timeStamp,
      data,
      strideY,
      strideU,
      strideV,
      textureId,
      transformMatrix,
    ];
  }

  static VideoFrame decode(Object result) {
    result as List<Object?>;
    return VideoFrame(
      width: result[0] as int?,
      height: result[1] as int?,
      rotation: result[2] as int?,
      format: result[3] as int?,
      timeStamp: result[4] as int?,
      data: result[5] as Uint8List?,
      strideY: result[6] as int?,
      strideU: result[7] as int?,
      strideV: result[8] as int?,
      textureId: result[9] as int?,
      transformMatrix: (result[10] as List<Object?>?)?.cast<double?>(),
    );
  }
}

class _NERtcChannelEventSinkCodec extends StandardMessageCodec {
  const _NERtcChannelEventSinkCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is AudioVolumeInfo) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else if (value is FirstVideoDataReceivedEvent) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else if (value is FirstVideoFrameDecodedEvent) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else if (value is NERtcLastmileProbeOneWayResult) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else if (value is NERtcLastmileProbeResult) {
      buffer.putUint8(132);
      writeValue(buffer, value.encode());
    } else if (value is NERtcUserJoinExtraInfo) {
      buffer.putUint8(133);
      writeValue(buffer, value.encode());
    } else if (value is NERtcUserLeaveExtraInfo) {
      buffer.putUint8(134);
      writeValue(buffer, value.encode());
    } else if (value is RemoteAudioVolumeIndicationEvent) {
      buffer.putUint8(135);
      writeValue(buffer, value.encode());
    } else if (value is UserJoinedEvent) {
      buffer.putUint8(136);
      writeValue(buffer, value.encode());
    } else if (value is UserLeaveEvent) {
      buffer.putUint8(137);
      writeValue(buffer, value.encode());
    } else if (value is UserVideoMuteEvent) {
      buffer.putUint8(138);
      writeValue(buffer, value.encode());
    } else if (value is VirtualBackgroundSourceEnabledEvent) {
      buffer.putUint8(139);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return AudioVolumeInfo.decode(readValue(buffer)!);
      case 129:
        return FirstVideoDataReceivedEvent.decode(readValue(buffer)!);
      case 130:
        return FirstVideoFrameDecodedEvent.decode(readValue(buffer)!);
      case 131:
        return NERtcLastmileProbeOneWayResult.decode(readValue(buffer)!);
      case 132:
        return NERtcLastmileProbeResult.decode(readValue(buffer)!);
      case 133:
        return NERtcUserJoinExtraInfo.decode(readValue(buffer)!);
      case 134:
        return NERtcUserLeaveExtraInfo.decode(readValue(buffer)!);
      case 135:
        return RemoteAudioVolumeIndicationEvent.decode(readValue(buffer)!);
      case 136:
        return UserJoinedEvent.decode(readValue(buffer)!);
      case 137:
        return UserLeaveEvent.decode(readValue(buffer)!);
      case 138:
        return UserVideoMuteEvent.decode(readValue(buffer)!);
      case 139:
        return VirtualBackgroundSourceEnabledEvent.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

abstract class NERtcChannelEventSink {
  static const MessageCodec<Object?> codec = _NERtcChannelEventSinkCodec();

  void onJoinChannel(int result, int channelId, int elapsed, int uid);

  void onLeaveChannel(int result);

  void onUserJoined(UserJoinedEvent event);

  void onUserLeave(UserLeaveEvent event);

  void onUserAudioStart(int uid);

  void onUserSubStreamAudioStart(int uid);

  void onUserAudioStop(int uid);

  void onUserSubStreamAudioStop(int uid);

  void onUserVideoStart(int uid, int maxProfile);

  void onUserVideoStop(int uid);

  void onDisconnect(int reason);

  void onUserAudioMute(int uid, bool muted);

  void onUserVideoMute(UserVideoMuteEvent event);

  void onUserSubStreamAudioMute(int uid, bool muted);

  void onFirstAudioDataReceived(int uid);

  void onFirstVideoDataReceived(FirstVideoDataReceivedEvent event);

  void onFirstAudioFrameDecoded(int uid);

  void onFirstVideoFrameDecoded(FirstVideoFrameDecodedEvent event);

  void onVirtualBackgroundSourceEnabled(
      VirtualBackgroundSourceEnabledEvent event);

  void onConnectionTypeChanged(int newConnectionType);

  void onReconnectingStart();

  void onReJoinChannel(int result, int channelId);

  void onConnectionStateChanged(int state, int reason);

  void onLocalAudioVolumeIndication(int volume, bool vadFlag);

  void onRemoteAudioVolumeIndication(RemoteAudioVolumeIndicationEvent event);

  void onLiveStreamState(String taskId, String pushUrl, int liveState);

  void onClientRoleChange(int oldRole, int newRole);

  void onError(int code);

  void onWarning(int code);

  void onUserSubStreamVideoStart(int uid, int maxProfile);

  void onUserSubStreamVideoStop(int uid);

  void onAudioHasHowling();

  void onRecvSEIMsg(int userID, String seiMsg);

  void onAudioRecording(int code, String filePath);

  void onMediaRightChange(
      bool isAudioBannedByServer, bool isVideoBannedByServer);

  void onMediaRelayStatesChange(int state, String channelName);

  void onMediaRelayReceiveEvent(int event, int code, String channelName);

  void onLocalPublishFallbackToAudioOnly(bool isFallback, int streamType);

  void onRemoteSubscribeFallbackToAudioOnly(
      int uid, bool isFallback, int streamType);

  void onLocalVideoWatermarkState(int videoStreamType, int state);

  void onLastmileQuality(int quality);

  void onLastmileProbeResult(NERtcLastmileProbeResult result);

  void onTakeSnapshotResult(int code, String path);

  static void setup(NERtcChannelEventSink? api,
      {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onJoinChannel', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onJoinChannel was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_result = (args[0] as int?);
          assert(arg_result != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onJoinChannel was null, expected non-null int.');
          final int? arg_channelId = (args[1] as int?);
          assert(arg_channelId != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onJoinChannel was null, expected non-null int.');
          final int? arg_elapsed = (args[2] as int?);
          assert(arg_elapsed != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onJoinChannel was null, expected non-null int.');
          final int? arg_uid = (args[3] as int?);
          assert(arg_uid != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onJoinChannel was null, expected non-null int.');
          api.onJoinChannel(
              arg_result!, arg_channelId!, arg_elapsed!, arg_uid!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onLeaveChannel', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onLeaveChannel was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_result = (args[0] as int?);
          assert(arg_result != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onLeaveChannel was null, expected non-null int.');
          api.onLeaveChannel(arg_result!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onUserJoined', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserJoined was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final UserJoinedEvent? arg_event = (args[0] as UserJoinedEvent?);
          assert(arg_event != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserJoined was null, expected non-null UserJoinedEvent.');
          api.onUserJoined(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onUserLeave', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserLeave was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final UserLeaveEvent? arg_event = (args[0] as UserLeaveEvent?);
          assert(arg_event != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserLeave was null, expected non-null UserLeaveEvent.');
          api.onUserLeave(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onUserAudioStart', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserAudioStart was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_uid = (args[0] as int?);
          assert(arg_uid != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserAudioStart was null, expected non-null int.');
          api.onUserAudioStart(arg_uid!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onUserSubStreamAudioStart',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserSubStreamAudioStart was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_uid = (args[0] as int?);
          assert(arg_uid != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserSubStreamAudioStart was null, expected non-null int.');
          api.onUserSubStreamAudioStart(arg_uid!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onUserAudioStop', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserAudioStop was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_uid = (args[0] as int?);
          assert(arg_uid != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserAudioStop was null, expected non-null int.');
          api.onUserAudioStop(arg_uid!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onUserSubStreamAudioStop',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserSubStreamAudioStop was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_uid = (args[0] as int?);
          assert(arg_uid != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserSubStreamAudioStop was null, expected non-null int.');
          api.onUserSubStreamAudioStop(arg_uid!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onUserVideoStart', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserVideoStart was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_uid = (args[0] as int?);
          assert(arg_uid != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserVideoStart was null, expected non-null int.');
          final int? arg_maxProfile = (args[1] as int?);
          assert(arg_maxProfile != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserVideoStart was null, expected non-null int.');
          api.onUserVideoStart(arg_uid!, arg_maxProfile!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onUserVideoStop', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserVideoStop was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_uid = (args[0] as int?);
          assert(arg_uid != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserVideoStop was null, expected non-null int.');
          api.onUserVideoStop(arg_uid!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onDisconnect', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onDisconnect was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_reason = (args[0] as int?);
          assert(arg_reason != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onDisconnect was null, expected non-null int.');
          api.onDisconnect(arg_reason!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onUserAudioMute', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserAudioMute was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_uid = (args[0] as int?);
          assert(arg_uid != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserAudioMute was null, expected non-null int.');
          final bool? arg_muted = (args[1] as bool?);
          assert(arg_muted != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserAudioMute was null, expected non-null bool.');
          api.onUserAudioMute(arg_uid!, arg_muted!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onUserVideoMute', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserVideoMute was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final UserVideoMuteEvent? arg_event =
              (args[0] as UserVideoMuteEvent?);
          assert(arg_event != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserVideoMute was null, expected non-null UserVideoMuteEvent.');
          api.onUserVideoMute(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onUserSubStreamAudioMute',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserSubStreamAudioMute was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_uid = (args[0] as int?);
          assert(arg_uid != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserSubStreamAudioMute was null, expected non-null int.');
          final bool? arg_muted = (args[1] as bool?);
          assert(arg_muted != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserSubStreamAudioMute was null, expected non-null bool.');
          api.onUserSubStreamAudioMute(arg_uid!, arg_muted!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onFirstAudioDataReceived',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onFirstAudioDataReceived was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_uid = (args[0] as int?);
          assert(arg_uid != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onFirstAudioDataReceived was null, expected non-null int.');
          api.onFirstAudioDataReceived(arg_uid!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onFirstVideoDataReceived',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onFirstVideoDataReceived was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final FirstVideoDataReceivedEvent? arg_event =
              (args[0] as FirstVideoDataReceivedEvent?);
          assert(arg_event != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onFirstVideoDataReceived was null, expected non-null FirstVideoDataReceivedEvent.');
          api.onFirstVideoDataReceived(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onFirstAudioFrameDecoded',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onFirstAudioFrameDecoded was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_uid = (args[0] as int?);
          assert(arg_uid != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onFirstAudioFrameDecoded was null, expected non-null int.');
          api.onFirstAudioFrameDecoded(arg_uid!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onFirstVideoFrameDecoded',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onFirstVideoFrameDecoded was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final FirstVideoFrameDecodedEvent? arg_event =
              (args[0] as FirstVideoFrameDecodedEvent?);
          assert(arg_event != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onFirstVideoFrameDecoded was null, expected non-null FirstVideoFrameDecodedEvent.');
          api.onFirstVideoFrameDecoded(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onVirtualBackgroundSourceEnabled',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onVirtualBackgroundSourceEnabled was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final VirtualBackgroundSourceEnabledEvent? arg_event =
              (args[0] as VirtualBackgroundSourceEnabledEvent?);
          assert(arg_event != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onVirtualBackgroundSourceEnabled was null, expected non-null VirtualBackgroundSourceEnabledEvent.');
          api.onVirtualBackgroundSourceEnabled(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onConnectionTypeChanged',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onConnectionTypeChanged was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_newConnectionType = (args[0] as int?);
          assert(arg_newConnectionType != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onConnectionTypeChanged was null, expected non-null int.');
          api.onConnectionTypeChanged(arg_newConnectionType!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onReconnectingStart', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          // ignore message
          api.onReconnectingStart();
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onReJoinChannel', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onReJoinChannel was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_result = (args[0] as int?);
          assert(arg_result != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onReJoinChannel was null, expected non-null int.');
          final int? arg_channelId = (args[1] as int?);
          assert(arg_channelId != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onReJoinChannel was null, expected non-null int.');
          api.onReJoinChannel(arg_result!, arg_channelId!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onConnectionStateChanged',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onConnectionStateChanged was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_state = (args[0] as int?);
          assert(arg_state != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onConnectionStateChanged was null, expected non-null int.');
          final int? arg_reason = (args[1] as int?);
          assert(arg_reason != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onConnectionStateChanged was null, expected non-null int.');
          api.onConnectionStateChanged(arg_state!, arg_reason!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onLocalAudioVolumeIndication',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onLocalAudioVolumeIndication was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_volume = (args[0] as int?);
          assert(arg_volume != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onLocalAudioVolumeIndication was null, expected non-null int.');
          final bool? arg_vadFlag = (args[1] as bool?);
          assert(arg_vadFlag != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onLocalAudioVolumeIndication was null, expected non-null bool.');
          api.onLocalAudioVolumeIndication(arg_volume!, arg_vadFlag!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onRemoteAudioVolumeIndication',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onRemoteAudioVolumeIndication was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final RemoteAudioVolumeIndicationEvent? arg_event =
              (args[0] as RemoteAudioVolumeIndicationEvent?);
          assert(arg_event != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onRemoteAudioVolumeIndication was null, expected non-null RemoteAudioVolumeIndicationEvent.');
          api.onRemoteAudioVolumeIndication(arg_event!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onLiveStreamState', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onLiveStreamState was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final String? arg_taskId = (args[0] as String?);
          assert(arg_taskId != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onLiveStreamState was null, expected non-null String.');
          final String? arg_pushUrl = (args[1] as String?);
          assert(arg_pushUrl != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onLiveStreamState was null, expected non-null String.');
          final int? arg_liveState = (args[2] as int?);
          assert(arg_liveState != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onLiveStreamState was null, expected non-null int.');
          api.onLiveStreamState(arg_taskId!, arg_pushUrl!, arg_liveState!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onClientRoleChange', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onClientRoleChange was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_oldRole = (args[0] as int?);
          assert(arg_oldRole != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onClientRoleChange was null, expected non-null int.');
          final int? arg_newRole = (args[1] as int?);
          assert(arg_newRole != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onClientRoleChange was null, expected non-null int.');
          api.onClientRoleChange(arg_oldRole!, arg_newRole!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onError', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onError was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_code = (args[0] as int?);
          assert(arg_code != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onError was null, expected non-null int.');
          api.onError(arg_code!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onWarning', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onWarning was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_code = (args[0] as int?);
          assert(arg_code != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onWarning was null, expected non-null int.');
          api.onWarning(arg_code!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onUserSubStreamVideoStart',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserSubStreamVideoStart was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_uid = (args[0] as int?);
          assert(arg_uid != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserSubStreamVideoStart was null, expected non-null int.');
          final int? arg_maxProfile = (args[1] as int?);
          assert(arg_maxProfile != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserSubStreamVideoStart was null, expected non-null int.');
          api.onUserSubStreamVideoStart(arg_uid!, arg_maxProfile!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onUserSubStreamVideoStop',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserSubStreamVideoStop was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_uid = (args[0] as int?);
          assert(arg_uid != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onUserSubStreamVideoStop was null, expected non-null int.');
          api.onUserSubStreamVideoStop(arg_uid!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onAudioHasHowling', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          // ignore message
          api.onAudioHasHowling();
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onRecvSEIMsg', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onRecvSEIMsg was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_userID = (args[0] as int?);
          assert(arg_userID != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onRecvSEIMsg was null, expected non-null int.');
          final String? arg_seiMsg = (args[1] as String?);
          assert(arg_seiMsg != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onRecvSEIMsg was null, expected non-null String.');
          api.onRecvSEIMsg(arg_userID!, arg_seiMsg!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onAudioRecording', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onAudioRecording was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_code = (args[0] as int?);
          assert(arg_code != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onAudioRecording was null, expected non-null int.');
          final String? arg_filePath = (args[1] as String?);
          assert(arg_filePath != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onAudioRecording was null, expected non-null String.');
          api.onAudioRecording(arg_code!, arg_filePath!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onMediaRightChange', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onMediaRightChange was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final bool? arg_isAudioBannedByServer = (args[0] as bool?);
          assert(arg_isAudioBannedByServer != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onMediaRightChange was null, expected non-null bool.');
          final bool? arg_isVideoBannedByServer = (args[1] as bool?);
          assert(arg_isVideoBannedByServer != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onMediaRightChange was null, expected non-null bool.');
          api.onMediaRightChange(
              arg_isAudioBannedByServer!, arg_isVideoBannedByServer!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onMediaRelayStatesChange',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onMediaRelayStatesChange was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_state = (args[0] as int?);
          assert(arg_state != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onMediaRelayStatesChange was null, expected non-null int.');
          final String? arg_channelName = (args[1] as String?);
          assert(arg_channelName != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onMediaRelayStatesChange was null, expected non-null String.');
          api.onMediaRelayStatesChange(arg_state!, arg_channelName!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onMediaRelayReceiveEvent',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onMediaRelayReceiveEvent was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_event = (args[0] as int?);
          assert(arg_event != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onMediaRelayReceiveEvent was null, expected non-null int.');
          final int? arg_code = (args[1] as int?);
          assert(arg_code != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onMediaRelayReceiveEvent was null, expected non-null int.');
          final String? arg_channelName = (args[2] as String?);
          assert(arg_channelName != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onMediaRelayReceiveEvent was null, expected non-null String.');
          api.onMediaRelayReceiveEvent(arg_event!, arg_code!, arg_channelName!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onLocalPublishFallbackToAudioOnly',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onLocalPublishFallbackToAudioOnly was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final bool? arg_isFallback = (args[0] as bool?);
          assert(arg_isFallback != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onLocalPublishFallbackToAudioOnly was null, expected non-null bool.');
          final int? arg_streamType = (args[1] as int?);
          assert(arg_streamType != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onLocalPublishFallbackToAudioOnly was null, expected non-null int.');
          api.onLocalPublishFallbackToAudioOnly(
              arg_isFallback!, arg_streamType!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onRemoteSubscribeFallbackToAudioOnly',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onRemoteSubscribeFallbackToAudioOnly was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_uid = (args[0] as int?);
          assert(arg_uid != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onRemoteSubscribeFallbackToAudioOnly was null, expected non-null int.');
          final bool? arg_isFallback = (args[1] as bool?);
          assert(arg_isFallback != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onRemoteSubscribeFallbackToAudioOnly was null, expected non-null bool.');
          final int? arg_streamType = (args[2] as int?);
          assert(arg_streamType != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onRemoteSubscribeFallbackToAudioOnly was null, expected non-null int.');
          api.onRemoteSubscribeFallbackToAudioOnly(
              arg_uid!, arg_isFallback!, arg_streamType!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onLocalVideoWatermarkState',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onLocalVideoWatermarkState was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_videoStreamType = (args[0] as int?);
          assert(arg_videoStreamType != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onLocalVideoWatermarkState was null, expected non-null int.');
          final int? arg_state = (args[1] as int?);
          assert(arg_state != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onLocalVideoWatermarkState was null, expected non-null int.');
          api.onLocalVideoWatermarkState(arg_videoStreamType!, arg_state!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onLastmileQuality', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onLastmileQuality was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_quality = (args[0] as int?);
          assert(arg_quality != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onLastmileQuality was null, expected non-null int.');
          api.onLastmileQuality(arg_quality!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onLastmileProbeResult',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onLastmileProbeResult was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final NERtcLastmileProbeResult? arg_result =
              (args[0] as NERtcLastmileProbeResult?);
          assert(arg_result != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onLastmileProbeResult was null, expected non-null NERtcLastmileProbeResult.');
          api.onLastmileProbeResult(arg_result!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcChannelEventSink.onTakeSnapshotResult',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onTakeSnapshotResult was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_code = (args[0] as int?);
          assert(arg_code != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onTakeSnapshotResult was null, expected non-null int.');
          final String? arg_path = (args[1] as String?);
          assert(arg_path != null,
              'Argument for dev.flutter.pigeon.NERtcChannelEventSink.onTakeSnapshotResult was null, expected non-null String.');
          api.onTakeSnapshotResult(arg_code!, arg_path!);
          return;
        });
      }
    }
  }
}

class _EngineApiCodec extends StandardMessageCodec {
  const _EngineApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is AddOrUpdateLiveStreamTaskRequest) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else if (value is AdjustUserPlaybackSignalVolumeRequest) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else if (value is AudioRecordingConfigurationRequest) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else if (value is AudioVolumeInfo) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else if (value is CGPoint) {
      buffer.putUint8(132);
      writeValue(buffer, value.encode());
    } else if (value is CreateEngineRequest) {
      buffer.putUint8(133);
      writeValue(buffer, value.encode());
    } else if (value is DeleteLiveStreamTaskRequest) {
      buffer.putUint8(134);
      writeValue(buffer, value.encode());
    } else if (value is EnableAudioVolumeIndicationRequest) {
      buffer.putUint8(135);
      writeValue(buffer, value.encode());
    } else if (value is EnableEncryptionRequest) {
      buffer.putUint8(136);
      writeValue(buffer, value.encode());
    } else if (value is EnableLocalVideoRequest) {
      buffer.putUint8(137);
      writeValue(buffer, value.encode());
    } else if (value is EnableVirtualBackgroundRequest) {
      buffer.putUint8(138);
      writeValue(buffer, value.encode());
    } else if (value is FirstVideoDataReceivedEvent) {
      buffer.putUint8(139);
      writeValue(buffer, value.encode());
    } else if (value is FirstVideoFrameDecodedEvent) {
      buffer.putUint8(140);
      writeValue(buffer, value.encode());
    } else if (value is JoinChannelOptions) {
      buffer.putUint8(141);
      writeValue(buffer, value.encode());
    } else if (value is JoinChannelRequest) {
      buffer.putUint8(142);
      writeValue(buffer, value.encode());
    } else if (value is NERtcLastmileProbeOneWayResult) {
      buffer.putUint8(143);
      writeValue(buffer, value.encode());
    } else if (value is NERtcLastmileProbeResult) {
      buffer.putUint8(144);
      writeValue(buffer, value.encode());
    } else if (value is NERtcUserJoinExtraInfo) {
      buffer.putUint8(145);
      writeValue(buffer, value.encode());
    } else if (value is NERtcUserLeaveExtraInfo) {
      buffer.putUint8(146);
      writeValue(buffer, value.encode());
    } else if (value is NERtcVersion) {
      buffer.putUint8(147);
      writeValue(buffer, value.encode());
    } else if (value is PlayEffectRequest) {
      buffer.putUint8(148);
      writeValue(buffer, value.encode());
    } else if (value is RemoteAudioVolumeIndicationEvent) {
      buffer.putUint8(149);
      writeValue(buffer, value.encode());
    } else if (value is ReportCustomEventRequest) {
      buffer.putUint8(150);
      writeValue(buffer, value.encode());
    } else if (value is RtcServerAddresses) {
      buffer.putUint8(151);
      writeValue(buffer, value.encode());
    } else if (value is SendSEIMsgRequest) {
      buffer.putUint8(152);
      writeValue(buffer, value.encode());
    } else if (value is SetAudioProfileRequest) {
      buffer.putUint8(153);
      writeValue(buffer, value.encode());
    } else if (value is SetAudioSubscribeOnlyByRequest) {
      buffer.putUint8(154);
      writeValue(buffer, value.encode());
    } else if (value is SetCameraCaptureConfigRequest) {
      buffer.putUint8(155);
      writeValue(buffer, value.encode());
    } else if (value is SetCameraPositionRequest) {
      buffer.putUint8(156);
      writeValue(buffer, value.encode());
    } else if (value is SetLocalMediaPriorityRequest) {
      buffer.putUint8(157);
      writeValue(buffer, value.encode());
    } else if (value is SetLocalVideoConfigRequest) {
      buffer.putUint8(158);
      writeValue(buffer, value.encode());
    } else if (value is SetLocalVideoWatermarkConfigsRequest) {
      buffer.putUint8(159);
      writeValue(buffer, value.encode());
    } else if (value is SetLocalVoiceEqualizationRequest) {
      buffer.putUint8(160);
      writeValue(buffer, value.encode());
    } else if (value is SetLocalVoiceReverbParamRequest) {
      buffer.putUint8(161);
      writeValue(buffer, value.encode());
    } else if (value is SetRemoteHighPriorityAudioStreamRequest) {
      buffer.putUint8(162);
      writeValue(buffer, value.encode());
    } else if (value is SetVideoCorrectionConfigRequest) {
      buffer.putUint8(163);
      writeValue(buffer, value.encode());
    } else if (value is StartAudioMixingRequest) {
      buffer.putUint8(164);
      writeValue(buffer, value.encode());
    } else if (value is StartAudioRecordingRequest) {
      buffer.putUint8(165);
      writeValue(buffer, value.encode());
    } else if (value is StartLastmileProbeTestRequest) {
      buffer.putUint8(166);
      writeValue(buffer, value.encode());
    } else if (value is StartOrUpdateChannelMediaRelayRequest) {
      buffer.putUint8(167);
      writeValue(buffer, value.encode());
    } else if (value is StartScreenCaptureRequest) {
      buffer.putUint8(168);
      writeValue(buffer, value.encode());
    } else if (value is StartorStopVideoPreviewRequest) {
      buffer.putUint8(169);
      writeValue(buffer, value.encode());
    } else if (value is SubscribeRemoteAudioRequest) {
      buffer.putUint8(170);
      writeValue(buffer, value.encode());
    } else if (value is SubscribeRemoteSubStreamAudioRequest) {
      buffer.putUint8(171);
      writeValue(buffer, value.encode());
    } else if (value is SubscribeRemoteSubStreamVideoRequest) {
      buffer.putUint8(172);
      writeValue(buffer, value.encode());
    } else if (value is SubscribeRemoteVideoStreamRequest) {
      buffer.putUint8(173);
      writeValue(buffer, value.encode());
    } else if (value is SwitchChannelRequest) {
      buffer.putUint8(174);
      writeValue(buffer, value.encode());
    } else if (value is UserJoinedEvent) {
      buffer.putUint8(175);
      writeValue(buffer, value.encode());
    } else if (value is UserLeaveEvent) {
      buffer.putUint8(176);
      writeValue(buffer, value.encode());
    } else if (value is UserVideoMuteEvent) {
      buffer.putUint8(177);
      writeValue(buffer, value.encode());
    } else if (value is VideoFrame) {
      buffer.putUint8(178);
      writeValue(buffer, value.encode());
    } else if (value is VideoWatermarkConfig) {
      buffer.putUint8(179);
      writeValue(buffer, value.encode());
    } else if (value is VideoWatermarkImageConfig) {
      buffer.putUint8(180);
      writeValue(buffer, value.encode());
    } else if (value is VideoWatermarkTextConfig) {
      buffer.putUint8(181);
      writeValue(buffer, value.encode());
    } else if (value is VideoWatermarkTimestampConfig) {
      buffer.putUint8(182);
      writeValue(buffer, value.encode());
    } else if (value is VirtualBackgroundSourceEnabledEvent) {
      buffer.putUint8(183);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return AddOrUpdateLiveStreamTaskRequest.decode(readValue(buffer)!);
      case 129:
        return AdjustUserPlaybackSignalVolumeRequest.decode(readValue(buffer)!);
      case 130:
        return AudioRecordingConfigurationRequest.decode(readValue(buffer)!);
      case 131:
        return AudioVolumeInfo.decode(readValue(buffer)!);
      case 132:
        return CGPoint.decode(readValue(buffer)!);
      case 133:
        return CreateEngineRequest.decode(readValue(buffer)!);
      case 134:
        return DeleteLiveStreamTaskRequest.decode(readValue(buffer)!);
      case 135:
        return EnableAudioVolumeIndicationRequest.decode(readValue(buffer)!);
      case 136:
        return EnableEncryptionRequest.decode(readValue(buffer)!);
      case 137:
        return EnableLocalVideoRequest.decode(readValue(buffer)!);
      case 138:
        return EnableVirtualBackgroundRequest.decode(readValue(buffer)!);
      case 139:
        return FirstVideoDataReceivedEvent.decode(readValue(buffer)!);
      case 140:
        return FirstVideoFrameDecodedEvent.decode(readValue(buffer)!);
      case 141:
        return JoinChannelOptions.decode(readValue(buffer)!);
      case 142:
        return JoinChannelRequest.decode(readValue(buffer)!);
      case 143:
        return NERtcLastmileProbeOneWayResult.decode(readValue(buffer)!);
      case 144:
        return NERtcLastmileProbeResult.decode(readValue(buffer)!);
      case 145:
        return NERtcUserJoinExtraInfo.decode(readValue(buffer)!);
      case 146:
        return NERtcUserLeaveExtraInfo.decode(readValue(buffer)!);
      case 147:
        return NERtcVersion.decode(readValue(buffer)!);
      case 148:
        return PlayEffectRequest.decode(readValue(buffer)!);
      case 149:
        return RemoteAudioVolumeIndicationEvent.decode(readValue(buffer)!);
      case 150:
        return ReportCustomEventRequest.decode(readValue(buffer)!);
      case 151:
        return RtcServerAddresses.decode(readValue(buffer)!);
      case 152:
        return SendSEIMsgRequest.decode(readValue(buffer)!);
      case 153:
        return SetAudioProfileRequest.decode(readValue(buffer)!);
      case 154:
        return SetAudioSubscribeOnlyByRequest.decode(readValue(buffer)!);
      case 155:
        return SetCameraCaptureConfigRequest.decode(readValue(buffer)!);
      case 156:
        return SetCameraPositionRequest.decode(readValue(buffer)!);
      case 157:
        return SetLocalMediaPriorityRequest.decode(readValue(buffer)!);
      case 158:
        return SetLocalVideoConfigRequest.decode(readValue(buffer)!);
      case 159:
        return SetLocalVideoWatermarkConfigsRequest.decode(readValue(buffer)!);
      case 160:
        return SetLocalVoiceEqualizationRequest.decode(readValue(buffer)!);
      case 161:
        return SetLocalVoiceReverbParamRequest.decode(readValue(buffer)!);
      case 162:
        return SetRemoteHighPriorityAudioStreamRequest.decode(
            readValue(buffer)!);
      case 163:
        return SetVideoCorrectionConfigRequest.decode(readValue(buffer)!);
      case 164:
        return StartAudioMixingRequest.decode(readValue(buffer)!);
      case 165:
        return StartAudioRecordingRequest.decode(readValue(buffer)!);
      case 166:
        return StartLastmileProbeTestRequest.decode(readValue(buffer)!);
      case 167:
        return StartOrUpdateChannelMediaRelayRequest.decode(readValue(buffer)!);
      case 168:
        return StartScreenCaptureRequest.decode(readValue(buffer)!);
      case 169:
        return StartorStopVideoPreviewRequest.decode(readValue(buffer)!);
      case 170:
        return SubscribeRemoteAudioRequest.decode(readValue(buffer)!);
      case 171:
        return SubscribeRemoteSubStreamAudioRequest.decode(readValue(buffer)!);
      case 172:
        return SubscribeRemoteSubStreamVideoRequest.decode(readValue(buffer)!);
      case 173:
        return SubscribeRemoteVideoStreamRequest.decode(readValue(buffer)!);
      case 174:
        return SwitchChannelRequest.decode(readValue(buffer)!);
      case 175:
        return UserJoinedEvent.decode(readValue(buffer)!);
      case 176:
        return UserLeaveEvent.decode(readValue(buffer)!);
      case 177:
        return UserVideoMuteEvent.decode(readValue(buffer)!);
      case 178:
        return VideoFrame.decode(readValue(buffer)!);
      case 179:
        return VideoWatermarkConfig.decode(readValue(buffer)!);
      case 180:
        return VideoWatermarkImageConfig.decode(readValue(buffer)!);
      case 181:
        return VideoWatermarkTextConfig.decode(readValue(buffer)!);
      case 182:
        return VideoWatermarkTimestampConfig.decode(readValue(buffer)!);
      case 183:
        return VirtualBackgroundSourceEnabledEvent.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

class EngineApi {
  /// Constructor for [EngineApi].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  EngineApi({BinaryMessenger? binaryMessenger})
      : _binaryMessenger = binaryMessenger;
  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = _EngineApiCodec();

  Future<int> create(CreateEngineRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.create', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<NERtcVersion> version() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.version', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as NERtcVersion?)!;
    }
  }

  Future<List<String?>?> checkPermission() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.checkPermission', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else {
      return (replyList[0] as List<Object?>?)?.cast<String?>();
    }
  }

  Future<int> setParameters(Map<String?, Object?> arg_params) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setParameters', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_params]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> release() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.release', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setStatsEventCallback() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setStatsEventCallback', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> clearStatsEventCallback() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.clearStatsEventCallback', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setChannelProfile(int arg_channelProfile) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setChannelProfile', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_channelProfile]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> joinChannel(JoinChannelRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.joinChannel', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> leaveChannel() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.leaveChannel', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> updatePermissionKey(String arg_key) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.updatePermissionKey', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_key]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> enableLocalAudio(bool arg_enable) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.enableLocalAudio', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_enable]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> subscribeRemoteAudio(
      SubscribeRemoteAudioRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.subscribeRemoteAudio', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> subscribeAllRemoteAudio(bool arg_subscribe) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.subscribeAllRemoteAudio', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_subscribe]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setAudioProfile(SetAudioProfileRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setAudioProfile', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> enableDualStreamMode(bool arg_enable) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.enableDualStreamMode', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_enable]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setLocalVideoConfig(
      SetLocalVideoConfigRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setLocalVideoConfig', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setCameraCaptureConfig(
      SetCameraCaptureConfigRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setCameraCaptureConfig', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> startVideoPreview(
      StartorStopVideoPreviewRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.startVideoPreview', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> stopVideoPreview(
      StartorStopVideoPreviewRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.stopVideoPreview', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> enableLocalVideo(EnableLocalVideoRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.enableLocalVideo', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> enableLocalSubStreamAudio(bool arg_enable) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.enableLocalSubStreamAudio', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_enable]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> subscribeRemoteSubStreamAudio(
      SubscribeRemoteSubStreamAudioRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.subscribeRemoteSubStreamAudio', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> muteLocalSubStreamAudio(bool arg_muted) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.muteLocalSubStreamAudio', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_muted]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setAudioSubscribeOnlyBy(
      SetAudioSubscribeOnlyByRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setAudioSubscribeOnlyBy', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> startScreenCapture(StartScreenCaptureRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.startScreenCapture', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> stopScreenCapture() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.stopScreenCapture', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> enableLoopbackRecording(bool arg_enable) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.enableLoopbackRecording', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_enable]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> subscribeRemoteVideoStream(
      SubscribeRemoteVideoStreamRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.subscribeRemoteVideoStream', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> subscribeRemoteSubStreamVideo(
      SubscribeRemoteSubStreamVideoRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.subscribeRemoteSubStreamVideo', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> muteLocalAudioStream(bool arg_mute) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.muteLocalAudioStream', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_mute]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> muteLocalVideoStream(bool arg_mute, int arg_streamType) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.muteLocalVideoStream', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel
        .send(<Object?>[arg_mute, arg_streamType]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> startAudioDump() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.startAudioDump', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> startAudioDumpWithType(int arg_dumpType) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.startAudioDumpWithType', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_dumpType]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> stopAudioDump() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.stopAudioDump', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> enableAudioVolumeIndication(
      EnableAudioVolumeIndicationRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.enableAudioVolumeIndication', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> adjustRecordingSignalVolume(int arg_volume) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.adjustRecordingSignalVolume', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_volume]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> adjustPlaybackSignalVolume(int arg_volume) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.adjustPlaybackSignalVolume', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_volume]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> adjustLoopBackRecordingSignalVolume(int arg_volume) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.adjustLoopBackRecordingSignalVolume',
        codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_volume]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> addLiveStreamTask(
      AddOrUpdateLiveStreamTaskRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.addLiveStreamTask', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> updateLiveStreamTask(
      AddOrUpdateLiveStreamTaskRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.updateLiveStreamTask', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> removeLiveStreamTask(
      DeleteLiveStreamTaskRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.removeLiveStreamTask', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setClientRole(int arg_role) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setClientRole', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_role]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> getConnectionState() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.getConnectionState', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> uploadSdkInfo() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.uploadSdkInfo', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> sendSEIMsg(SendSEIMsgRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.sendSEIMsg', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setLocalVoiceReverbParam(
      SetLocalVoiceReverbParamRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setLocalVoiceReverbParam', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setAudioEffectPreset(int arg_preset) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setAudioEffectPreset', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_preset]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setVoiceBeautifierPreset(int arg_preset) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setVoiceBeautifierPreset', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_preset]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setLocalVoicePitch(double arg_pitch) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setLocalVoicePitch', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_pitch]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setLocalVoiceEqualization(
      SetLocalVoiceEqualizationRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setLocalVoiceEqualization', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> switchChannel(SwitchChannelRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.switchChannel', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> startAudioRecording(
      StartAudioRecordingRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.startAudioRecording', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> startAudioRecordingWithConfig(
      AudioRecordingConfigurationRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.startAudioRecordingWithConfig', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> stopAudioRecording() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.stopAudioRecording', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setLocalMediaPriority(
      SetLocalMediaPriorityRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setLocalMediaPriority', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> enableMediaPub(int arg_mediaType, bool arg_enable) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.enableMediaPub', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel
        .send(<Object?>[arg_mediaType, arg_enable]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> startChannelMediaRelay(
      StartOrUpdateChannelMediaRelayRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.startChannelMediaRelay', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> updateChannelMediaRelay(
      StartOrUpdateChannelMediaRelayRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.updateChannelMediaRelay', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> stopChannelMediaRelay() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.stopChannelMediaRelay', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> adjustUserPlaybackSignalVolume(
      AdjustUserPlaybackSignalVolumeRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.adjustUserPlaybackSignalVolume', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setLocalPublishFallbackOption(int arg_option) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setLocalPublishFallbackOption', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_option]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setRemoteSubscribeFallbackOption(int arg_option) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setRemoteSubscribeFallbackOption', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_option]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> enableSuperResolution(bool arg_enable) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.enableSuperResolution', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_enable]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> enableEncryption(EnableEncryptionRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.enableEncryption', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setAudioSessionOperationRestriction(int arg_option) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setAudioSessionOperationRestriction',
        codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_option]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> enableVideoCorrection(bool arg_enable) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.enableVideoCorrection', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_enable]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> reportCustomEvent(ReportCustomEventRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.reportCustomEvent', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> getEffectDuration(int arg_effectId) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.getEffectDuration', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_effectId]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> startLastmileProbeTest(
      StartLastmileProbeTestRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.startLastmileProbeTest', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> stopLastmileProbeTest() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.stopLastmileProbeTest', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setVideoCorrectionConfig(
      SetVideoCorrectionConfigRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setVideoCorrectionConfig', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> enableVirtualBackground(
      EnableVirtualBackgroundRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.enableVirtualBackground', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setRemoteHighPriorityAudioStream(
      SetRemoteHighPriorityAudioStreamRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setRemoteHighPriorityAudioStream', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setCloudProxy(int arg_proxyType) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setCloudProxy', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_proxyType]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> startBeauty() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.startBeauty', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<void> stopBeauty() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.stopBeauty', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else {
      return;
    }
  }

  Future<int> enableBeauty(bool arg_enabled) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.enableBeauty', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_enabled]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setBeautyEffect(double arg_level, int arg_beautyType) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setBeautyEffect', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel
        .send(<Object?>[arg_level, arg_beautyType]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> addBeautyFilter(String arg_path, String arg_name) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.addBeautyFilter', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_path, arg_name]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<void> removeBeautyFilter() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.removeBeautyFilter', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else {
      return;
    }
  }

  Future<int> setBeautyFilterLevel(double arg_level) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setBeautyFilterLevel', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_level]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setLocalVideoWatermarkConfigs(
      SetLocalVideoWatermarkConfigsRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setLocalVideoWatermarkConfigs', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setStreamAlignmentProperty(bool arg_enable) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setStreamAlignmentProperty', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_enable]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> getNtpTimeOffset() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.getNtpTimeOffset', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> takeLocalSnapshot(int arg_streamType, String arg_path) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.takeLocalSnapshot', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel
        .send(<Object?>[arg_streamType, arg_path]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> takeRemoteSnapshot(
      int arg_uid, int arg_streamType, String arg_path) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.takeRemoteSnapshot', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel
        .send(<Object?>[arg_uid, arg_streamType, arg_path]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setExternalVideoSource(
      int arg_streamType, bool arg_enable) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.setExternalVideoSource', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel
        .send(<Object?>[arg_streamType, arg_enable]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> pushExternalVideoFrame(
      int arg_streamType, VideoFrame arg_frame) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.EngineApi.pushExternalVideoFrame', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel
        .send(<Object?>[arg_streamType, arg_frame]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }
}

class VideoRendererApi {
  /// Constructor for [VideoRendererApi].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  VideoRendererApi({BinaryMessenger? binaryMessenger})
      : _binaryMessenger = binaryMessenger;
  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = StandardMessageCodec();

  Future<int> createVideoRenderer() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.VideoRendererApi.createVideoRenderer', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setMirror(int arg_textureId, bool arg_mirror) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.VideoRendererApi.setMirror', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel
        .send(<Object?>[arg_textureId, arg_mirror]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setupLocalVideoRenderer(int arg_textureId) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.VideoRendererApi.setupLocalVideoRenderer', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_textureId]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setupRemoteVideoRenderer(int arg_uid, int arg_textureId) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.VideoRendererApi.setupRemoteVideoRenderer', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_uid, arg_textureId]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setupLocalSubStreamVideoRenderer(int arg_textureId) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.VideoRendererApi.setupLocalSubStreamVideoRenderer',
        codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_textureId]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setupRemoteSubStreamVideoRenderer(
      int arg_uid, int arg_textureId) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.VideoRendererApi.setupRemoteSubStreamVideoRenderer',
        codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_uid, arg_textureId]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<void> disposeVideoRenderer(int arg_textureId) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.VideoRendererApi.disposeVideoRenderer', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_textureId]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else {
      return;
    }
  }
}

class _NERtcDeviceEventSinkCodec extends StandardMessageCodec {
  const _NERtcDeviceEventSinkCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is CGPoint) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return CGPoint.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

abstract class NERtcDeviceEventSink {
  static const MessageCodec<Object?> codec = _NERtcDeviceEventSinkCodec();

  void onAudioDeviceChanged(int selected);

  void onAudioDeviceStateChange(int deviceType, int deviceState);

  void onVideoDeviceStateChange(int deviceType, int deviceState);

  void onCameraFocusChanged(CGPoint focusPoint);

  void onCameraExposureChanged(CGPoint exposurePoint);

  static void setup(NERtcDeviceEventSink? api,
      {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcDeviceEventSink.onAudioDeviceChanged', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcDeviceEventSink.onAudioDeviceChanged was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_selected = (args[0] as int?);
          assert(arg_selected != null,
              'Argument for dev.flutter.pigeon.NERtcDeviceEventSink.onAudioDeviceChanged was null, expected non-null int.');
          api.onAudioDeviceChanged(arg_selected!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcDeviceEventSink.onAudioDeviceStateChange',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcDeviceEventSink.onAudioDeviceStateChange was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_deviceType = (args[0] as int?);
          assert(arg_deviceType != null,
              'Argument for dev.flutter.pigeon.NERtcDeviceEventSink.onAudioDeviceStateChange was null, expected non-null int.');
          final int? arg_deviceState = (args[1] as int?);
          assert(arg_deviceState != null,
              'Argument for dev.flutter.pigeon.NERtcDeviceEventSink.onAudioDeviceStateChange was null, expected non-null int.');
          api.onAudioDeviceStateChange(arg_deviceType!, arg_deviceState!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcDeviceEventSink.onVideoDeviceStateChange',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcDeviceEventSink.onVideoDeviceStateChange was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_deviceType = (args[0] as int?);
          assert(arg_deviceType != null,
              'Argument for dev.flutter.pigeon.NERtcDeviceEventSink.onVideoDeviceStateChange was null, expected non-null int.');
          final int? arg_deviceState = (args[1] as int?);
          assert(arg_deviceState != null,
              'Argument for dev.flutter.pigeon.NERtcDeviceEventSink.onVideoDeviceStateChange was null, expected non-null int.');
          api.onVideoDeviceStateChange(arg_deviceType!, arg_deviceState!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcDeviceEventSink.onCameraFocusChanged', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcDeviceEventSink.onCameraFocusChanged was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final CGPoint? arg_focusPoint = (args[0] as CGPoint?);
          assert(arg_focusPoint != null,
              'Argument for dev.flutter.pigeon.NERtcDeviceEventSink.onCameraFocusChanged was null, expected non-null CGPoint.');
          api.onCameraFocusChanged(arg_focusPoint!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcDeviceEventSink.onCameraExposureChanged',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcDeviceEventSink.onCameraExposureChanged was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final CGPoint? arg_exposurePoint = (args[0] as CGPoint?);
          assert(arg_exposurePoint != null,
              'Argument for dev.flutter.pigeon.NERtcDeviceEventSink.onCameraExposureChanged was null, expected non-null CGPoint.');
          api.onCameraExposureChanged(arg_exposurePoint!);
          return;
        });
      }
    }
  }
}

class _DeviceManagerApiCodec extends StandardMessageCodec {
  const _DeviceManagerApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is SetCameraPositionRequest) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return SetCameraPositionRequest.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

class DeviceManagerApi {
  /// Constructor for [DeviceManagerApi].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  DeviceManagerApi({BinaryMessenger? binaryMessenger})
      : _binaryMessenger = binaryMessenger;
  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = _DeviceManagerApiCodec();

  Future<bool> isSpeakerphoneOn() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.isSpeakerphoneOn', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as bool?)!;
    }
  }

  Future<bool> isCameraZoomSupported() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.isCameraZoomSupported', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as bool?)!;
    }
  }

  Future<bool> isCameraTorchSupported() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.isCameraTorchSupported', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as bool?)!;
    }
  }

  Future<bool> isCameraFocusSupported() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.isCameraFocusSupported', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as bool?)!;
    }
  }

  Future<bool> isCameraExposurePositionSupported() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.isCameraExposurePositionSupported',
        codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as bool?)!;
    }
  }

  Future<int> setSpeakerphoneOn(bool arg_enable) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.setSpeakerphoneOn', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_enable]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> switchCamera() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.switchCamera', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setCameraZoomFactor(double arg_factor) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.setCameraZoomFactor', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_factor]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<double> getCameraMaxZoom() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.getCameraMaxZoom', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as double?)!;
    }
  }

  Future<int> setCameraTorchOn(bool arg_on) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.setCameraTorchOn', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_on]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setCameraFocusPosition(
      SetCameraPositionRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.setCameraFocusPosition', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setCameraExposurePosition(
      SetCameraPositionRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.setCameraExposurePosition', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setPlayoutDeviceMute(bool arg_mute) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.setPlayoutDeviceMute', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_mute]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<bool> isPlayoutDeviceMute() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.isPlayoutDeviceMute', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as bool?)!;
    }
  }

  Future<int> setRecordDeviceMute(bool arg_mute) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.setRecordDeviceMute', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_mute]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<bool> isRecordDeviceMute() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.isRecordDeviceMute', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as bool?)!;
    }
  }

  Future<int> enableEarback(bool arg_enabled, int arg_volume) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.enableEarback', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel
        .send(<Object?>[arg_enabled, arg_volume]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setEarbackVolume(int arg_volume) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.setEarbackVolume', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_volume]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setAudioFocusMode(int arg_focusMode) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.setAudioFocusMode', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_focusMode]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> getCurrentCamera() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.getCurrentCamera', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> switchCameraWithPosition(int arg_position) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.switchCameraWithPosition', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_position]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> getCameraCurrentZoom() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.DeviceManagerApi.getCameraCurrentZoom', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }
}

class _AudioMixingApiCodec extends StandardMessageCodec {
  const _AudioMixingApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is StartAudioMixingRequest) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return StartAudioMixingRequest.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

class AudioMixingApi {
  /// Constructor for [AudioMixingApi].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  AudioMixingApi({BinaryMessenger? binaryMessenger})
      : _binaryMessenger = binaryMessenger;
  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = _AudioMixingApiCodec();

  Future<int> startAudioMixing(StartAudioMixingRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioMixingApi.startAudioMixing', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> stopAudioMixing() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioMixingApi.stopAudioMixing', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> pauseAudioMixing() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioMixingApi.pauseAudioMixing', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> resumeAudioMixing() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioMixingApi.resumeAudioMixing', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setAudioMixingSendVolume(int arg_volume) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioMixingApi.setAudioMixingSendVolume', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_volume]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> getAudioMixingSendVolume() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioMixingApi.getAudioMixingSendVolume', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setAudioMixingPlaybackVolume(int arg_volume) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioMixingApi.setAudioMixingPlaybackVolume', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_volume]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> getAudioMixingPlaybackVolume() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioMixingApi.getAudioMixingPlaybackVolume', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> getAudioMixingDuration() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioMixingApi.getAudioMixingDuration', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> getAudioMixingCurrentPosition() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioMixingApi.getAudioMixingCurrentPosition',
        codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setAudioMixingPosition(int arg_position) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioMixingApi.setAudioMixingPosition', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_position]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setAudioMixingPitch(int arg_pitch) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioMixingApi.setAudioMixingPitch', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_pitch]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> getAudioMixingPitch() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioMixingApi.getAudioMixingPitch', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }
}

abstract class NERtcAudioMixingEventSink {
  static const MessageCodec<Object?> codec = StandardMessageCodec();

  void onAudioMixingStateChanged(int reason);

  void onAudioMixingTimestampUpdate(int timestampMs);

  static void setup(NERtcAudioMixingEventSink? api,
      {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcAudioMixingEventSink.onAudioMixingStateChanged',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcAudioMixingEventSink.onAudioMixingStateChanged was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_reason = (args[0] as int?);
          assert(arg_reason != null,
              'Argument for dev.flutter.pigeon.NERtcAudioMixingEventSink.onAudioMixingStateChanged was null, expected non-null int.');
          api.onAudioMixingStateChanged(arg_reason!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcAudioMixingEventSink.onAudioMixingTimestampUpdate',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcAudioMixingEventSink.onAudioMixingTimestampUpdate was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_timestampMs = (args[0] as int?);
          assert(arg_timestampMs != null,
              'Argument for dev.flutter.pigeon.NERtcAudioMixingEventSink.onAudioMixingTimestampUpdate was null, expected non-null int.');
          api.onAudioMixingTimestampUpdate(arg_timestampMs!);
          return;
        });
      }
    }
  }
}

class _AudioEffectApiCodec extends StandardMessageCodec {
  const _AudioEffectApiCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is PlayEffectRequest) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return PlayEffectRequest.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

class AudioEffectApi {
  /// Constructor for [AudioEffectApi].  The [binaryMessenger] named argument is
  /// available for dependency injection.  If it is left null, the default
  /// BinaryMessenger will be used which routes to the host platform.
  AudioEffectApi({BinaryMessenger? binaryMessenger})
      : _binaryMessenger = binaryMessenger;
  final BinaryMessenger? _binaryMessenger;

  static const MessageCodec<Object?> codec = _AudioEffectApiCodec();

  Future<int> playEffect(PlayEffectRequest arg_request) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioEffectApi.playEffect', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_request]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> stopEffect(int arg_effectId) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioEffectApi.stopEffect', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_effectId]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> stopAllEffects() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioEffectApi.stopAllEffects', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> pauseEffect(int arg_effectId) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioEffectApi.pauseEffect', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_effectId]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> resumeEffect(int arg_effectId) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioEffectApi.resumeEffect', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_effectId]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> pauseAllEffects() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioEffectApi.pauseAllEffects', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> resumeAllEffects() async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioEffectApi.resumeAllEffects', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel.send(null) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setEffectSendVolume(int arg_effectId, int arg_volume) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioEffectApi.setEffectSendVolume', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel
        .send(<Object?>[arg_effectId, arg_volume]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> getEffectSendVolume(int arg_effectId) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioEffectApi.getEffectSendVolume', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_effectId]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setEffectPlaybackVolume(int arg_effectId, int arg_volume) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioEffectApi.setEffectPlaybackVolume', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel
        .send(<Object?>[arg_effectId, arg_volume]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> getEffectPlaybackVolume(int arg_effectId) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioEffectApi.getEffectPlaybackVolume', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_effectId]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> getEffectDuration(int arg_effectId) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioEffectApi.getEffectDuration', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_effectId]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> getEffectCurrentPosition(int arg_effectId) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioEffectApi.getEffectCurrentPosition', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_effectId]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setEffectPitch(int arg_effectId, int arg_pitch) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioEffectApi.setEffectPitch', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel
        .send(<Object?>[arg_effectId, arg_pitch]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> getEffectPitch(int arg_effectId) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioEffectApi.getEffectPitch', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList =
        await channel.send(<Object?>[arg_effectId]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }

  Future<int> setEffectPosition(int arg_effectId, int arg_position) async {
    final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
        'dev.flutter.pigeon.AudioEffectApi.setEffectPosition', codec,
        binaryMessenger: _binaryMessenger);
    final List<Object?>? replyList = await channel
        .send(<Object?>[arg_effectId, arg_position]) as List<Object?>?;
    if (replyList == null) {
      throw PlatformException(
        code: 'channel-error',
        message: 'Unable to establish connection on channel.',
      );
    } else if (replyList.length > 1) {
      throw PlatformException(
        code: replyList[0]! as String,
        message: replyList[1] as String?,
        details: replyList[2],
      );
    } else if (replyList[0] == null) {
      throw PlatformException(
        code: 'null-error',
        message: 'Host platform returned null value for non-null return value.',
      );
    } else {
      return (replyList[0] as int?)!;
    }
  }
}

abstract class NERtcAudioEffectEventSink {
  static const MessageCodec<Object?> codec = StandardMessageCodec();

  void onAudioEffectFinished(int effectId);

  void onAudioEffectTimestampUpdate(int id, int timestampMs);

  static void setup(NERtcAudioEffectEventSink? api,
      {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcAudioEffectEventSink.onAudioEffectFinished',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcAudioEffectEventSink.onAudioEffectFinished was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_effectId = (args[0] as int?);
          assert(arg_effectId != null,
              'Argument for dev.flutter.pigeon.NERtcAudioEffectEventSink.onAudioEffectFinished was null, expected non-null int.');
          api.onAudioEffectFinished(arg_effectId!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcAudioEffectEventSink.onAudioEffectTimestampUpdate',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcAudioEffectEventSink.onAudioEffectTimestampUpdate was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final int? arg_id = (args[0] as int?);
          assert(arg_id != null,
              'Argument for dev.flutter.pigeon.NERtcAudioEffectEventSink.onAudioEffectTimestampUpdate was null, expected non-null int.');
          final int? arg_timestampMs = (args[1] as int?);
          assert(arg_timestampMs != null,
              'Argument for dev.flutter.pigeon.NERtcAudioEffectEventSink.onAudioEffectTimestampUpdate was null, expected non-null int.');
          api.onAudioEffectTimestampUpdate(arg_id!, arg_timestampMs!);
          return;
        });
      }
    }
  }
}

class _NERtcStatsEventSinkCodec extends StandardMessageCodec {
  const _NERtcStatsEventSinkCodec();
  @override
  void writeValue(WriteBuffer buffer, Object? value) {
    if (value is AddOrUpdateLiveStreamTaskRequest) {
      buffer.putUint8(128);
      writeValue(buffer, value.encode());
    } else if (value is AdjustUserPlaybackSignalVolumeRequest) {
      buffer.putUint8(129);
      writeValue(buffer, value.encode());
    } else if (value is AudioRecordingConfigurationRequest) {
      buffer.putUint8(130);
      writeValue(buffer, value.encode());
    } else if (value is AudioVolumeInfo) {
      buffer.putUint8(131);
      writeValue(buffer, value.encode());
    } else if (value is CGPoint) {
      buffer.putUint8(132);
      writeValue(buffer, value.encode());
    } else if (value is CreateEngineRequest) {
      buffer.putUint8(133);
      writeValue(buffer, value.encode());
    } else if (value is DeleteLiveStreamTaskRequest) {
      buffer.putUint8(134);
      writeValue(buffer, value.encode());
    } else if (value is EnableAudioVolumeIndicationRequest) {
      buffer.putUint8(135);
      writeValue(buffer, value.encode());
    } else if (value is EnableEncryptionRequest) {
      buffer.putUint8(136);
      writeValue(buffer, value.encode());
    } else if (value is EnableLocalVideoRequest) {
      buffer.putUint8(137);
      writeValue(buffer, value.encode());
    } else if (value is EnableVirtualBackgroundRequest) {
      buffer.putUint8(138);
      writeValue(buffer, value.encode());
    } else if (value is FirstVideoDataReceivedEvent) {
      buffer.putUint8(139);
      writeValue(buffer, value.encode());
    } else if (value is FirstVideoFrameDecodedEvent) {
      buffer.putUint8(140);
      writeValue(buffer, value.encode());
    } else if (value is JoinChannelOptions) {
      buffer.putUint8(141);
      writeValue(buffer, value.encode());
    } else if (value is JoinChannelRequest) {
      buffer.putUint8(142);
      writeValue(buffer, value.encode());
    } else if (value is NERtcLastmileProbeOneWayResult) {
      buffer.putUint8(143);
      writeValue(buffer, value.encode());
    } else if (value is NERtcLastmileProbeResult) {
      buffer.putUint8(144);
      writeValue(buffer, value.encode());
    } else if (value is NERtcUserJoinExtraInfo) {
      buffer.putUint8(145);
      writeValue(buffer, value.encode());
    } else if (value is NERtcUserLeaveExtraInfo) {
      buffer.putUint8(146);
      writeValue(buffer, value.encode());
    } else if (value is NERtcVersion) {
      buffer.putUint8(147);
      writeValue(buffer, value.encode());
    } else if (value is PlayEffectRequest) {
      buffer.putUint8(148);
      writeValue(buffer, value.encode());
    } else if (value is RemoteAudioVolumeIndicationEvent) {
      buffer.putUint8(149);
      writeValue(buffer, value.encode());
    } else if (value is ReportCustomEventRequest) {
      buffer.putUint8(150);
      writeValue(buffer, value.encode());
    } else if (value is RtcServerAddresses) {
      buffer.putUint8(151);
      writeValue(buffer, value.encode());
    } else if (value is SendSEIMsgRequest) {
      buffer.putUint8(152);
      writeValue(buffer, value.encode());
    } else if (value is SetAudioProfileRequest) {
      buffer.putUint8(153);
      writeValue(buffer, value.encode());
    } else if (value is SetAudioSubscribeOnlyByRequest) {
      buffer.putUint8(154);
      writeValue(buffer, value.encode());
    } else if (value is SetCameraCaptureConfigRequest) {
      buffer.putUint8(155);
      writeValue(buffer, value.encode());
    } else if (value is SetCameraPositionRequest) {
      buffer.putUint8(156);
      writeValue(buffer, value.encode());
    } else if (value is SetLocalMediaPriorityRequest) {
      buffer.putUint8(157);
      writeValue(buffer, value.encode());
    } else if (value is SetLocalVideoConfigRequest) {
      buffer.putUint8(158);
      writeValue(buffer, value.encode());
    } else if (value is SetLocalVideoWatermarkConfigsRequest) {
      buffer.putUint8(159);
      writeValue(buffer, value.encode());
    } else if (value is SetLocalVoiceEqualizationRequest) {
      buffer.putUint8(160);
      writeValue(buffer, value.encode());
    } else if (value is SetLocalVoiceReverbParamRequest) {
      buffer.putUint8(161);
      writeValue(buffer, value.encode());
    } else if (value is SetRemoteHighPriorityAudioStreamRequest) {
      buffer.putUint8(162);
      writeValue(buffer, value.encode());
    } else if (value is SetVideoCorrectionConfigRequest) {
      buffer.putUint8(163);
      writeValue(buffer, value.encode());
    } else if (value is StartAudioMixingRequest) {
      buffer.putUint8(164);
      writeValue(buffer, value.encode());
    } else if (value is StartAudioRecordingRequest) {
      buffer.putUint8(165);
      writeValue(buffer, value.encode());
    } else if (value is StartLastmileProbeTestRequest) {
      buffer.putUint8(166);
      writeValue(buffer, value.encode());
    } else if (value is StartOrUpdateChannelMediaRelayRequest) {
      buffer.putUint8(167);
      writeValue(buffer, value.encode());
    } else if (value is StartScreenCaptureRequest) {
      buffer.putUint8(168);
      writeValue(buffer, value.encode());
    } else if (value is StartorStopVideoPreviewRequest) {
      buffer.putUint8(169);
      writeValue(buffer, value.encode());
    } else if (value is SubscribeRemoteAudioRequest) {
      buffer.putUint8(170);
      writeValue(buffer, value.encode());
    } else if (value is SubscribeRemoteSubStreamAudioRequest) {
      buffer.putUint8(171);
      writeValue(buffer, value.encode());
    } else if (value is SubscribeRemoteSubStreamVideoRequest) {
      buffer.putUint8(172);
      writeValue(buffer, value.encode());
    } else if (value is SubscribeRemoteVideoStreamRequest) {
      buffer.putUint8(173);
      writeValue(buffer, value.encode());
    } else if (value is SwitchChannelRequest) {
      buffer.putUint8(174);
      writeValue(buffer, value.encode());
    } else if (value is UserJoinedEvent) {
      buffer.putUint8(175);
      writeValue(buffer, value.encode());
    } else if (value is UserLeaveEvent) {
      buffer.putUint8(176);
      writeValue(buffer, value.encode());
    } else if (value is UserVideoMuteEvent) {
      buffer.putUint8(177);
      writeValue(buffer, value.encode());
    } else if (value is VideoFrame) {
      buffer.putUint8(178);
      writeValue(buffer, value.encode());
    } else if (value is VideoWatermarkConfig) {
      buffer.putUint8(179);
      writeValue(buffer, value.encode());
    } else if (value is VideoWatermarkImageConfig) {
      buffer.putUint8(180);
      writeValue(buffer, value.encode());
    } else if (value is VideoWatermarkTextConfig) {
      buffer.putUint8(181);
      writeValue(buffer, value.encode());
    } else if (value is VideoWatermarkTimestampConfig) {
      buffer.putUint8(182);
      writeValue(buffer, value.encode());
    } else if (value is VirtualBackgroundSourceEnabledEvent) {
      buffer.putUint8(183);
      writeValue(buffer, value.encode());
    } else {
      super.writeValue(buffer, value);
    }
  }

  @override
  Object? readValueOfType(int type, ReadBuffer buffer) {
    switch (type) {
      case 128:
        return AddOrUpdateLiveStreamTaskRequest.decode(readValue(buffer)!);
      case 129:
        return AdjustUserPlaybackSignalVolumeRequest.decode(readValue(buffer)!);
      case 130:
        return AudioRecordingConfigurationRequest.decode(readValue(buffer)!);
      case 131:
        return AudioVolumeInfo.decode(readValue(buffer)!);
      case 132:
        return CGPoint.decode(readValue(buffer)!);
      case 133:
        return CreateEngineRequest.decode(readValue(buffer)!);
      case 134:
        return DeleteLiveStreamTaskRequest.decode(readValue(buffer)!);
      case 135:
        return EnableAudioVolumeIndicationRequest.decode(readValue(buffer)!);
      case 136:
        return EnableEncryptionRequest.decode(readValue(buffer)!);
      case 137:
        return EnableLocalVideoRequest.decode(readValue(buffer)!);
      case 138:
        return EnableVirtualBackgroundRequest.decode(readValue(buffer)!);
      case 139:
        return FirstVideoDataReceivedEvent.decode(readValue(buffer)!);
      case 140:
        return FirstVideoFrameDecodedEvent.decode(readValue(buffer)!);
      case 141:
        return JoinChannelOptions.decode(readValue(buffer)!);
      case 142:
        return JoinChannelRequest.decode(readValue(buffer)!);
      case 143:
        return NERtcLastmileProbeOneWayResult.decode(readValue(buffer)!);
      case 144:
        return NERtcLastmileProbeResult.decode(readValue(buffer)!);
      case 145:
        return NERtcUserJoinExtraInfo.decode(readValue(buffer)!);
      case 146:
        return NERtcUserLeaveExtraInfo.decode(readValue(buffer)!);
      case 147:
        return NERtcVersion.decode(readValue(buffer)!);
      case 148:
        return PlayEffectRequest.decode(readValue(buffer)!);
      case 149:
        return RemoteAudioVolumeIndicationEvent.decode(readValue(buffer)!);
      case 150:
        return ReportCustomEventRequest.decode(readValue(buffer)!);
      case 151:
        return RtcServerAddresses.decode(readValue(buffer)!);
      case 152:
        return SendSEIMsgRequest.decode(readValue(buffer)!);
      case 153:
        return SetAudioProfileRequest.decode(readValue(buffer)!);
      case 154:
        return SetAudioSubscribeOnlyByRequest.decode(readValue(buffer)!);
      case 155:
        return SetCameraCaptureConfigRequest.decode(readValue(buffer)!);
      case 156:
        return SetCameraPositionRequest.decode(readValue(buffer)!);
      case 157:
        return SetLocalMediaPriorityRequest.decode(readValue(buffer)!);
      case 158:
        return SetLocalVideoConfigRequest.decode(readValue(buffer)!);
      case 159:
        return SetLocalVideoWatermarkConfigsRequest.decode(readValue(buffer)!);
      case 160:
        return SetLocalVoiceEqualizationRequest.decode(readValue(buffer)!);
      case 161:
        return SetLocalVoiceReverbParamRequest.decode(readValue(buffer)!);
      case 162:
        return SetRemoteHighPriorityAudioStreamRequest.decode(
            readValue(buffer)!);
      case 163:
        return SetVideoCorrectionConfigRequest.decode(readValue(buffer)!);
      case 164:
        return StartAudioMixingRequest.decode(readValue(buffer)!);
      case 165:
        return StartAudioRecordingRequest.decode(readValue(buffer)!);
      case 166:
        return StartLastmileProbeTestRequest.decode(readValue(buffer)!);
      case 167:
        return StartOrUpdateChannelMediaRelayRequest.decode(readValue(buffer)!);
      case 168:
        return StartScreenCaptureRequest.decode(readValue(buffer)!);
      case 169:
        return StartorStopVideoPreviewRequest.decode(readValue(buffer)!);
      case 170:
        return SubscribeRemoteAudioRequest.decode(readValue(buffer)!);
      case 171:
        return SubscribeRemoteSubStreamAudioRequest.decode(readValue(buffer)!);
      case 172:
        return SubscribeRemoteSubStreamVideoRequest.decode(readValue(buffer)!);
      case 173:
        return SubscribeRemoteVideoStreamRequest.decode(readValue(buffer)!);
      case 174:
        return SwitchChannelRequest.decode(readValue(buffer)!);
      case 175:
        return UserJoinedEvent.decode(readValue(buffer)!);
      case 176:
        return UserLeaveEvent.decode(readValue(buffer)!);
      case 177:
        return UserVideoMuteEvent.decode(readValue(buffer)!);
      case 178:
        return VideoFrame.decode(readValue(buffer)!);
      case 179:
        return VideoWatermarkConfig.decode(readValue(buffer)!);
      case 180:
        return VideoWatermarkImageConfig.decode(readValue(buffer)!);
      case 181:
        return VideoWatermarkTextConfig.decode(readValue(buffer)!);
      case 182:
        return VideoWatermarkTimestampConfig.decode(readValue(buffer)!);
      case 183:
        return VirtualBackgroundSourceEnabledEvent.decode(readValue(buffer)!);
      default:
        return super.readValueOfType(type, buffer);
    }
  }
}

abstract class NERtcStatsEventSink {
  static const MessageCodec<Object?> codec = _NERtcStatsEventSinkCodec();

  void onRtcStats(Map<Object?, Object?> arguments);

  void onLocalAudioStats(Map<Object?, Object?> arguments);

  void onRemoteAudioStats(Map<Object?, Object?> arguments);

  void onLocalVideoStats(Map<Object?, Object?> arguments);

  void onRemoteVideoStats(Map<Object?, Object?> arguments);

  void onNetworkQuality(Map<Object?, Object?> arguments);

  static void setup(NERtcStatsEventSink? api,
      {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcStatsEventSink.onRtcStats', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcStatsEventSink.onRtcStats was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Map<Object?, Object?>? arg_arguments =
              (args[0] as Map<Object?, Object?>?)?.cast<Object?, Object?>();
          assert(arg_arguments != null,
              'Argument for dev.flutter.pigeon.NERtcStatsEventSink.onRtcStats was null, expected non-null Map<Object?, Object?>.');
          api.onRtcStats(arg_arguments!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcStatsEventSink.onLocalAudioStats', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcStatsEventSink.onLocalAudioStats was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Map<Object?, Object?>? arg_arguments =
              (args[0] as Map<Object?, Object?>?)?.cast<Object?, Object?>();
          assert(arg_arguments != null,
              'Argument for dev.flutter.pigeon.NERtcStatsEventSink.onLocalAudioStats was null, expected non-null Map<Object?, Object?>.');
          api.onLocalAudioStats(arg_arguments!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcStatsEventSink.onRemoteAudioStats', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcStatsEventSink.onRemoteAudioStats was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Map<Object?, Object?>? arg_arguments =
              (args[0] as Map<Object?, Object?>?)?.cast<Object?, Object?>();
          assert(arg_arguments != null,
              'Argument for dev.flutter.pigeon.NERtcStatsEventSink.onRemoteAudioStats was null, expected non-null Map<Object?, Object?>.');
          api.onRemoteAudioStats(arg_arguments!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcStatsEventSink.onLocalVideoStats', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcStatsEventSink.onLocalVideoStats was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Map<Object?, Object?>? arg_arguments =
              (args[0] as Map<Object?, Object?>?)?.cast<Object?, Object?>();
          assert(arg_arguments != null,
              'Argument for dev.flutter.pigeon.NERtcStatsEventSink.onLocalVideoStats was null, expected non-null Map<Object?, Object?>.');
          api.onLocalVideoStats(arg_arguments!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcStatsEventSink.onRemoteVideoStats', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcStatsEventSink.onRemoteVideoStats was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Map<Object?, Object?>? arg_arguments =
              (args[0] as Map<Object?, Object?>?)?.cast<Object?, Object?>();
          assert(arg_arguments != null,
              'Argument for dev.flutter.pigeon.NERtcStatsEventSink.onRemoteVideoStats was null, expected non-null Map<Object?, Object?>.');
          api.onRemoteVideoStats(arg_arguments!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcStatsEventSink.onNetworkQuality', codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcStatsEventSink.onNetworkQuality was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final Map<Object?, Object?>? arg_arguments =
              (args[0] as Map<Object?, Object?>?)?.cast<Object?, Object?>();
          assert(arg_arguments != null,
              'Argument for dev.flutter.pigeon.NERtcStatsEventSink.onNetworkQuality was null, expected non-null Map<Object?, Object?>.');
          api.onNetworkQuality(arg_arguments!);
          return;
        });
      }
    }
  }
}

abstract class NERtcLiveStreamEventSink {
  static const MessageCodec<Object?> codec = StandardMessageCodec();

  void onUpdateLiveStreamTask(String taskId, int errCode);

  void onAddLiveStreamTask(String taskId, int errCode);

  void onDeleteLiveStreamTask(String taskId, int errCode);

  static void setup(NERtcLiveStreamEventSink? api,
      {BinaryMessenger? binaryMessenger}) {
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcLiveStreamEventSink.onUpdateLiveStreamTask',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcLiveStreamEventSink.onUpdateLiveStreamTask was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final String? arg_taskId = (args[0] as String?);
          assert(arg_taskId != null,
              'Argument for dev.flutter.pigeon.NERtcLiveStreamEventSink.onUpdateLiveStreamTask was null, expected non-null String.');
          final int? arg_errCode = (args[1] as int?);
          assert(arg_errCode != null,
              'Argument for dev.flutter.pigeon.NERtcLiveStreamEventSink.onUpdateLiveStreamTask was null, expected non-null int.');
          api.onUpdateLiveStreamTask(arg_taskId!, arg_errCode!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcLiveStreamEventSink.onAddLiveStreamTask',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcLiveStreamEventSink.onAddLiveStreamTask was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final String? arg_taskId = (args[0] as String?);
          assert(arg_taskId != null,
              'Argument for dev.flutter.pigeon.NERtcLiveStreamEventSink.onAddLiveStreamTask was null, expected non-null String.');
          final int? arg_errCode = (args[1] as int?);
          assert(arg_errCode != null,
              'Argument for dev.flutter.pigeon.NERtcLiveStreamEventSink.onAddLiveStreamTask was null, expected non-null int.');
          api.onAddLiveStreamTask(arg_taskId!, arg_errCode!);
          return;
        });
      }
    }
    {
      final BasicMessageChannel<Object?> channel = BasicMessageChannel<Object?>(
          'dev.flutter.pigeon.NERtcLiveStreamEventSink.onDeleteLiveStreamTask',
          codec,
          binaryMessenger: binaryMessenger);
      if (api == null) {
        channel.setMessageHandler(null);
      } else {
        channel.setMessageHandler((Object? message) async {
          assert(message != null,
              'Argument for dev.flutter.pigeon.NERtcLiveStreamEventSink.onDeleteLiveStreamTask was null.');
          final List<Object?> args = (message as List<Object?>?)!;
          final String? arg_taskId = (args[0] as String?);
          assert(arg_taskId != null,
              'Argument for dev.flutter.pigeon.NERtcLiveStreamEventSink.onDeleteLiveStreamTask was null, expected non-null String.');
          final int? arg_errCode = (args[1] as int?);
          assert(arg_errCode != null,
              'Argument for dev.flutter.pigeon.NERtcLiveStreamEventSink.onDeleteLiveStreamTask was null, expected non-null int.');
          api.onDeleteLiveStreamTask(arg_taskId!, arg_errCode!);
          return;
        });
      }
    }
  }
}
